
user/_grind:     file format elf64-littleriscv


Disassembly of section .text:

0000000000000000 <do_rand>:
#include "kernel/riscv.h"

// from FreeBSD.
int
do_rand(unsigned long *ctx)
{
       0:	7139                	addi	sp,sp,-64
       2:	fc22                	sd	s0,56(sp)
       4:	0080                	addi	s0,sp,64
       6:	fca43423          	sd	a0,-56(s0)
 * October 1988, p. 1195.
 */
    long hi, lo, x;

    /* Transform to [1, 0x7ffffffe] range. */
    x = (*ctx % 0x7ffffffe) + 1;
       a:	fc843783          	ld	a5,-56(s0)
       e:	6398                	ld	a4,0(a5)
      10:	800007b7          	lui	a5,0x80000
      14:	ffe7c793          	xori	a5,a5,-2
      18:	02f777b3          	remu	a5,a4,a5
      1c:	0785                	addi	a5,a5,1
      1e:	fef43423          	sd	a5,-24(s0)
    hi = x / 127773;
      22:	fe843703          	ld	a4,-24(s0)
      26:	67fd                	lui	a5,0x1f
      28:	31d78793          	addi	a5,a5,797 # 1f31d <__global_pointer$+0x1cbbd>
      2c:	02f747b3          	div	a5,a4,a5
      30:	fef43023          	sd	a5,-32(s0)
    lo = x % 127773;
      34:	fe843703          	ld	a4,-24(s0)
      38:	67fd                	lui	a5,0x1f
      3a:	31d78793          	addi	a5,a5,797 # 1f31d <__global_pointer$+0x1cbbd>
      3e:	02f767b3          	rem	a5,a4,a5
      42:	fcf43c23          	sd	a5,-40(s0)
    x = 16807 * lo - 2836 * hi;
      46:	fd843703          	ld	a4,-40(s0)
      4a:	6791                	lui	a5,0x4
      4c:	1a778793          	addi	a5,a5,423 # 41a7 <__global_pointer$+0x1a47>
      50:	02f70733          	mul	a4,a4,a5
      54:	fe043683          	ld	a3,-32(s0)
      58:	77fd                	lui	a5,0xfffff
      5a:	4ec78793          	addi	a5,a5,1260 # fffffffffffff4ec <__global_pointer$+0xffffffffffffcd8c>
      5e:	02f687b3          	mul	a5,a3,a5
      62:	97ba                	add	a5,a5,a4
      64:	fef43423          	sd	a5,-24(s0)
    if (x < 0)
      68:	fe843783          	ld	a5,-24(s0)
      6c:	0007db63          	bgez	a5,82 <do_rand+0x82>
        x += 0x7fffffff;
      70:	fe843703          	ld	a4,-24(s0)
      74:	800007b7          	lui	a5,0x80000
      78:	fff7c793          	not	a5,a5
      7c:	97ba                	add	a5,a5,a4
      7e:	fef43423          	sd	a5,-24(s0)
    /* Transform to [0, 0x7ffffffd] range. */
    x--;
      82:	fe843783          	ld	a5,-24(s0)
      86:	17fd                	addi	a5,a5,-1
      88:	fef43423          	sd	a5,-24(s0)
    *ctx = x;
      8c:	fe843703          	ld	a4,-24(s0)
      90:	fc843783          	ld	a5,-56(s0)
      94:	e398                	sd	a4,0(a5)
    return (x);
      96:	fe843783          	ld	a5,-24(s0)
      9a:	2781                	sext.w	a5,a5
}
      9c:	853e                	mv	a0,a5
      9e:	7462                	ld	s0,56(sp)
      a0:	6121                	addi	sp,sp,64
      a2:	8082                	ret

00000000000000a4 <rand>:

unsigned long rand_next = 1;

int
rand(void)
{
      a4:	1141                	addi	sp,sp,-16
      a6:	e406                	sd	ra,8(sp)
      a8:	e022                	sd	s0,0(sp)
      aa:	0800                	addi	s0,sp,16
    return (do_rand(&rand_next));
      ac:	00002517          	auipc	a0,0x2
      b0:	ecc50513          	addi	a0,a0,-308 # 1f78 <rand_next>
      b4:	00000097          	auipc	ra,0x0
      b8:	f4c080e7          	jalr	-180(ra) # 0 <do_rand>
      bc:	87aa                	mv	a5,a0
}
      be:	853e                	mv	a0,a5
      c0:	60a2                	ld	ra,8(sp)
      c2:	6402                	ld	s0,0(sp)
      c4:	0141                	addi	sp,sp,16
      c6:	8082                	ret

00000000000000c8 <go>:

void
go(int which_child)
{
      c8:	7155                	addi	sp,sp,-208
      ca:	e586                	sd	ra,200(sp)
      cc:	e1a2                	sd	s0,192(sp)
      ce:	0980                	addi	s0,sp,208
      d0:	87aa                	mv	a5,a0
      d2:	f2f42e23          	sw	a5,-196(s0)
  int fd = -1;
      d6:	57fd                	li	a5,-1
      d8:	fef42623          	sw	a5,-20(s0)
  static char buf[999];
  char *break0 = sbrk(0);
      dc:	4501                	li	a0,0
      de:	00001097          	auipc	ra,0x1
      e2:	38e080e7          	jalr	910(ra) # 146c <sbrk>
      e6:	fca43c23          	sd	a0,-40(s0)
  uint64 iters = 0;
      ea:	fe043023          	sd	zero,-32(s0)

  mkdir("grindir");
      ee:	00002517          	auipc	a0,0x2
      f2:	b6a50513          	addi	a0,a0,-1174 # 1c58 <malloc+0x144>
      f6:	00001097          	auipc	ra,0x1
      fa:	356080e7          	jalr	854(ra) # 144c <mkdir>
  if(chdir("grindir") != 0){
      fe:	00002517          	auipc	a0,0x2
     102:	b5a50513          	addi	a0,a0,-1190 # 1c58 <malloc+0x144>
     106:	00001097          	auipc	ra,0x1
     10a:	34e080e7          	jalr	846(ra) # 1454 <chdir>
     10e:	87aa                	mv	a5,a0
     110:	cf91                	beqz	a5,12c <go+0x64>
    printf("grind: chdir grindir failed\n");
     112:	00002517          	auipc	a0,0x2
     116:	b4e50513          	addi	a0,a0,-1202 # 1c60 <malloc+0x14c>
     11a:	00002097          	auipc	ra,0x2
     11e:	808080e7          	jalr	-2040(ra) # 1922 <printf>
    exit(1);
     122:	4505                	li	a0,1
     124:	00001097          	auipc	ra,0x1
     128:	2c0080e7          	jalr	704(ra) # 13e4 <exit>
  }
  chdir("/");
     12c:	00002517          	auipc	a0,0x2
     130:	b5450513          	addi	a0,a0,-1196 # 1c80 <malloc+0x16c>
     134:	00001097          	auipc	ra,0x1
     138:	320080e7          	jalr	800(ra) # 1454 <chdir>
  
  while(1){
    iters++;
     13c:	fe043783          	ld	a5,-32(s0)
     140:	0785                	addi	a5,a5,1
     142:	fef43023          	sd	a5,-32(s0)
    if((iters % 500) == 0)
     146:	fe043703          	ld	a4,-32(s0)
     14a:	1f400793          	li	a5,500
     14e:	02f777b3          	remu	a5,a4,a5
     152:	e78d                	bnez	a5,17c <go+0xb4>
      write(1, which_child?"B":"A", 1);
     154:	f3c42783          	lw	a5,-196(s0)
     158:	2781                	sext.w	a5,a5
     15a:	c791                	beqz	a5,166 <go+0x9e>
     15c:	00002797          	auipc	a5,0x2
     160:	b2c78793          	addi	a5,a5,-1236 # 1c88 <malloc+0x174>
     164:	a029                	j	16e <go+0xa6>
     166:	00002797          	auipc	a5,0x2
     16a:	b2a78793          	addi	a5,a5,-1238 # 1c90 <malloc+0x17c>
     16e:	4605                	li	a2,1
     170:	85be                	mv	a1,a5
     172:	4505                	li	a0,1
     174:	00001097          	auipc	ra,0x1
     178:	290080e7          	jalr	656(ra) # 1404 <write>
    int what = rand() % 23;
     17c:	00000097          	auipc	ra,0x0
     180:	f28080e7          	jalr	-216(ra) # a4 <rand>
     184:	87aa                	mv	a5,a0
     186:	873e                	mv	a4,a5
     188:	47dd                	li	a5,23
     18a:	02f767bb          	remw	a5,a4,a5
     18e:	fcf42a23          	sw	a5,-44(s0)
    if(what == 1){
     192:	fd442783          	lw	a5,-44(s0)
     196:	0007871b          	sext.w	a4,a5
     19a:	4785                	li	a5,1
     19c:	02f71363          	bne	a4,a5,1c2 <go+0xfa>
      close(open("grindir/../a", O_CREATE|O_RDWR));
     1a0:	20200593          	li	a1,514
     1a4:	00002517          	auipc	a0,0x2
     1a8:	af450513          	addi	a0,a0,-1292 # 1c98 <malloc+0x184>
     1ac:	00001097          	auipc	ra,0x1
     1b0:	278080e7          	jalr	632(ra) # 1424 <open>
     1b4:	87aa                	mv	a5,a0
     1b6:	853e                	mv	a0,a5
     1b8:	00001097          	auipc	ra,0x1
     1bc:	254080e7          	jalr	596(ra) # 140c <close>
     1c0:	bfb5                	j	13c <go+0x74>
    } else if(what == 2){
     1c2:	fd442783          	lw	a5,-44(s0)
     1c6:	0007871b          	sext.w	a4,a5
     1ca:	4789                	li	a5,2
     1cc:	02f71363          	bne	a4,a5,1f2 <go+0x12a>
      close(open("grindir/../grindir/../b", O_CREATE|O_RDWR));
     1d0:	20200593          	li	a1,514
     1d4:	00002517          	auipc	a0,0x2
     1d8:	ad450513          	addi	a0,a0,-1324 # 1ca8 <malloc+0x194>
     1dc:	00001097          	auipc	ra,0x1
     1e0:	248080e7          	jalr	584(ra) # 1424 <open>
     1e4:	87aa                	mv	a5,a0
     1e6:	853e                	mv	a0,a5
     1e8:	00001097          	auipc	ra,0x1
     1ec:	224080e7          	jalr	548(ra) # 140c <close>
     1f0:	b7b1                	j	13c <go+0x74>
    } else if(what == 3){
     1f2:	fd442783          	lw	a5,-44(s0)
     1f6:	0007871b          	sext.w	a4,a5
     1fa:	478d                	li	a5,3
     1fc:	00f71b63          	bne	a4,a5,212 <go+0x14a>
      unlink("grindir/../a");
     200:	00002517          	auipc	a0,0x2
     204:	a9850513          	addi	a0,a0,-1384 # 1c98 <malloc+0x184>
     208:	00001097          	auipc	ra,0x1
     20c:	22c080e7          	jalr	556(ra) # 1434 <unlink>
     210:	b735                	j	13c <go+0x74>
    } else if(what == 4){
     212:	fd442783          	lw	a5,-44(s0)
     216:	0007871b          	sext.w	a4,a5
     21a:	4791                	li	a5,4
     21c:	04f71a63          	bne	a4,a5,270 <go+0x1a8>
      if(chdir("grindir") != 0){
     220:	00002517          	auipc	a0,0x2
     224:	a3850513          	addi	a0,a0,-1480 # 1c58 <malloc+0x144>
     228:	00001097          	auipc	ra,0x1
     22c:	22c080e7          	jalr	556(ra) # 1454 <chdir>
     230:	87aa                	mv	a5,a0
     232:	cf91                	beqz	a5,24e <go+0x186>
        printf("grind: chdir grindir failed\n");
     234:	00002517          	auipc	a0,0x2
     238:	a2c50513          	addi	a0,a0,-1492 # 1c60 <malloc+0x14c>
     23c:	00001097          	auipc	ra,0x1
     240:	6e6080e7          	jalr	1766(ra) # 1922 <printf>
        exit(1);
     244:	4505                	li	a0,1
     246:	00001097          	auipc	ra,0x1
     24a:	19e080e7          	jalr	414(ra) # 13e4 <exit>
      }
      unlink("../b");
     24e:	00002517          	auipc	a0,0x2
     252:	a7250513          	addi	a0,a0,-1422 # 1cc0 <malloc+0x1ac>
     256:	00001097          	auipc	ra,0x1
     25a:	1de080e7          	jalr	478(ra) # 1434 <unlink>
      chdir("/");
     25e:	00002517          	auipc	a0,0x2
     262:	a2250513          	addi	a0,a0,-1502 # 1c80 <malloc+0x16c>
     266:	00001097          	auipc	ra,0x1
     26a:	1ee080e7          	jalr	494(ra) # 1454 <chdir>
     26e:	b5f9                	j	13c <go+0x74>
    } else if(what == 5){
     270:	fd442783          	lw	a5,-44(s0)
     274:	0007871b          	sext.w	a4,a5
     278:	4795                	li	a5,5
     27a:	02f71763          	bne	a4,a5,2a8 <go+0x1e0>
      close(fd);
     27e:	fec42783          	lw	a5,-20(s0)
     282:	853e                	mv	a0,a5
     284:	00001097          	auipc	ra,0x1
     288:	188080e7          	jalr	392(ra) # 140c <close>
      fd = open("/grindir/../a", O_CREATE|O_RDWR);
     28c:	20200593          	li	a1,514
     290:	00002517          	auipc	a0,0x2
     294:	a3850513          	addi	a0,a0,-1480 # 1cc8 <malloc+0x1b4>
     298:	00001097          	auipc	ra,0x1
     29c:	18c080e7          	jalr	396(ra) # 1424 <open>
     2a0:	87aa                	mv	a5,a0
     2a2:	fef42623          	sw	a5,-20(s0)
     2a6:	bd59                	j	13c <go+0x74>
    } else if(what == 6){
     2a8:	fd442783          	lw	a5,-44(s0)
     2ac:	0007871b          	sext.w	a4,a5
     2b0:	4799                	li	a5,6
     2b2:	02f71763          	bne	a4,a5,2e0 <go+0x218>
      close(fd);
     2b6:	fec42783          	lw	a5,-20(s0)
     2ba:	853e                	mv	a0,a5
     2bc:	00001097          	auipc	ra,0x1
     2c0:	150080e7          	jalr	336(ra) # 140c <close>
      fd = open("/./grindir/./../b", O_CREATE|O_RDWR);
     2c4:	20200593          	li	a1,514
     2c8:	00002517          	auipc	a0,0x2
     2cc:	a1050513          	addi	a0,a0,-1520 # 1cd8 <malloc+0x1c4>
     2d0:	00001097          	auipc	ra,0x1
     2d4:	154080e7          	jalr	340(ra) # 1424 <open>
     2d8:	87aa                	mv	a5,a0
     2da:	fef42623          	sw	a5,-20(s0)
     2de:	bdb9                	j	13c <go+0x74>
    } else if(what == 7){
     2e0:	fd442783          	lw	a5,-44(s0)
     2e4:	0007871b          	sext.w	a4,a5
     2e8:	479d                	li	a5,7
     2ea:	02f71063          	bne	a4,a5,30a <go+0x242>
      write(fd, buf, sizeof(buf));
     2ee:	fec42783          	lw	a5,-20(s0)
     2f2:	3e700613          	li	a2,999
     2f6:	00002597          	auipc	a1,0x2
     2fa:	c8a58593          	addi	a1,a1,-886 # 1f80 <buf.1246>
     2fe:	853e                	mv	a0,a5
     300:	00001097          	auipc	ra,0x1
     304:	104080e7          	jalr	260(ra) # 1404 <write>
     308:	bd15                	j	13c <go+0x74>
    } else if(what == 8){
     30a:	fd442783          	lw	a5,-44(s0)
     30e:	0007871b          	sext.w	a4,a5
     312:	47a1                	li	a5,8
     314:	02f71063          	bne	a4,a5,334 <go+0x26c>
      read(fd, buf, sizeof(buf));
     318:	fec42783          	lw	a5,-20(s0)
     31c:	3e700613          	li	a2,999
     320:	00002597          	auipc	a1,0x2
     324:	c6058593          	addi	a1,a1,-928 # 1f80 <buf.1246>
     328:	853e                	mv	a0,a5
     32a:	00001097          	auipc	ra,0x1
     32e:	0d2080e7          	jalr	210(ra) # 13fc <read>
     332:	b529                	j	13c <go+0x74>
    } else if(what == 9){
     334:	fd442783          	lw	a5,-44(s0)
     338:	0007871b          	sext.w	a4,a5
     33c:	47a5                	li	a5,9
     33e:	04f71363          	bne	a4,a5,384 <go+0x2bc>
      mkdir("grindir/../a");
     342:	00002517          	auipc	a0,0x2
     346:	95650513          	addi	a0,a0,-1706 # 1c98 <malloc+0x184>
     34a:	00001097          	auipc	ra,0x1
     34e:	102080e7          	jalr	258(ra) # 144c <mkdir>
      close(open("a/../a/./a", O_CREATE|O_RDWR));
     352:	20200593          	li	a1,514
     356:	00002517          	auipc	a0,0x2
     35a:	99a50513          	addi	a0,a0,-1638 # 1cf0 <malloc+0x1dc>
     35e:	00001097          	auipc	ra,0x1
     362:	0c6080e7          	jalr	198(ra) # 1424 <open>
     366:	87aa                	mv	a5,a0
     368:	853e                	mv	a0,a5
     36a:	00001097          	auipc	ra,0x1
     36e:	0a2080e7          	jalr	162(ra) # 140c <close>
      unlink("a/a");
     372:	00002517          	auipc	a0,0x2
     376:	98e50513          	addi	a0,a0,-1650 # 1d00 <malloc+0x1ec>
     37a:	00001097          	auipc	ra,0x1
     37e:	0ba080e7          	jalr	186(ra) # 1434 <unlink>
     382:	bb6d                	j	13c <go+0x74>
    } else if(what == 10){
     384:	fd442783          	lw	a5,-44(s0)
     388:	0007871b          	sext.w	a4,a5
     38c:	47a9                	li	a5,10
     38e:	04f71363          	bne	a4,a5,3d4 <go+0x30c>
      mkdir("/../b");
     392:	00002517          	auipc	a0,0x2
     396:	97650513          	addi	a0,a0,-1674 # 1d08 <malloc+0x1f4>
     39a:	00001097          	auipc	ra,0x1
     39e:	0b2080e7          	jalr	178(ra) # 144c <mkdir>
      close(open("grindir/../b/b", O_CREATE|O_RDWR));
     3a2:	20200593          	li	a1,514
     3a6:	00002517          	auipc	a0,0x2
     3aa:	96a50513          	addi	a0,a0,-1686 # 1d10 <malloc+0x1fc>
     3ae:	00001097          	auipc	ra,0x1
     3b2:	076080e7          	jalr	118(ra) # 1424 <open>
     3b6:	87aa                	mv	a5,a0
     3b8:	853e                	mv	a0,a5
     3ba:	00001097          	auipc	ra,0x1
     3be:	052080e7          	jalr	82(ra) # 140c <close>
      unlink("b/b");
     3c2:	00002517          	auipc	a0,0x2
     3c6:	95e50513          	addi	a0,a0,-1698 # 1d20 <malloc+0x20c>
     3ca:	00001097          	auipc	ra,0x1
     3ce:	06a080e7          	jalr	106(ra) # 1434 <unlink>
     3d2:	b3ad                	j	13c <go+0x74>
    } else if(what == 11){
     3d4:	fd442783          	lw	a5,-44(s0)
     3d8:	0007871b          	sext.w	a4,a5
     3dc:	47ad                	li	a5,11
     3de:	02f71763          	bne	a4,a5,40c <go+0x344>
      unlink("b");
     3e2:	00002517          	auipc	a0,0x2
     3e6:	94650513          	addi	a0,a0,-1722 # 1d28 <malloc+0x214>
     3ea:	00001097          	auipc	ra,0x1
     3ee:	04a080e7          	jalr	74(ra) # 1434 <unlink>
      link("../grindir/./../a", "../b");
     3f2:	00002597          	auipc	a1,0x2
     3f6:	8ce58593          	addi	a1,a1,-1842 # 1cc0 <malloc+0x1ac>
     3fa:	00002517          	auipc	a0,0x2
     3fe:	93650513          	addi	a0,a0,-1738 # 1d30 <malloc+0x21c>
     402:	00001097          	auipc	ra,0x1
     406:	042080e7          	jalr	66(ra) # 1444 <link>
     40a:	bb0d                	j	13c <go+0x74>
    } else if(what == 12){
     40c:	fd442783          	lw	a5,-44(s0)
     410:	0007871b          	sext.w	a4,a5
     414:	47b1                	li	a5,12
     416:	02f71763          	bne	a4,a5,444 <go+0x37c>
      unlink("../grindir/../a");
     41a:	00002517          	auipc	a0,0x2
     41e:	92e50513          	addi	a0,a0,-1746 # 1d48 <malloc+0x234>
     422:	00001097          	auipc	ra,0x1
     426:	012080e7          	jalr	18(ra) # 1434 <unlink>
      link(".././b", "/grindir/../a");
     42a:	00002597          	auipc	a1,0x2
     42e:	89e58593          	addi	a1,a1,-1890 # 1cc8 <malloc+0x1b4>
     432:	00002517          	auipc	a0,0x2
     436:	92650513          	addi	a0,a0,-1754 # 1d58 <malloc+0x244>
     43a:	00001097          	auipc	ra,0x1
     43e:	00a080e7          	jalr	10(ra) # 1444 <link>
     442:	b9ed                	j	13c <go+0x74>
    } else if(what == 13){
     444:	fd442783          	lw	a5,-44(s0)
     448:	0007871b          	sext.w	a4,a5
     44c:	47b5                	li	a5,13
     44e:	04f71a63          	bne	a4,a5,4a2 <go+0x3da>
      int pid = fork();
     452:	00001097          	auipc	ra,0x1
     456:	f8a080e7          	jalr	-118(ra) # 13dc <fork>
     45a:	87aa                	mv	a5,a0
     45c:	faf42823          	sw	a5,-80(s0)
      if(pid == 0){
     460:	fb042783          	lw	a5,-80(s0)
     464:	2781                	sext.w	a5,a5
     466:	e791                	bnez	a5,472 <go+0x3aa>
        exit(0);
     468:	4501                	li	a0,0
     46a:	00001097          	auipc	ra,0x1
     46e:	f7a080e7          	jalr	-134(ra) # 13e4 <exit>
      } else if(pid < 0){
     472:	fb042783          	lw	a5,-80(s0)
     476:	2781                	sext.w	a5,a5
     478:	0007df63          	bgez	a5,496 <go+0x3ce>
        printf("grind: fork failed\n");
     47c:	00002517          	auipc	a0,0x2
     480:	8e450513          	addi	a0,a0,-1820 # 1d60 <malloc+0x24c>
     484:	00001097          	auipc	ra,0x1
     488:	49e080e7          	jalr	1182(ra) # 1922 <printf>
        exit(1);
     48c:	4505                	li	a0,1
     48e:	00001097          	auipc	ra,0x1
     492:	f56080e7          	jalr	-170(ra) # 13e4 <exit>
      }
      wait(0);
     496:	4501                	li	a0,0
     498:	00001097          	auipc	ra,0x1
     49c:	f54080e7          	jalr	-172(ra) # 13ec <wait>
     4a0:	b971                	j	13c <go+0x74>
    } else if(what == 14){
     4a2:	fd442783          	lw	a5,-44(s0)
     4a6:	0007871b          	sext.w	a4,a5
     4aa:	47b9                	li	a5,14
     4ac:	06f71263          	bne	a4,a5,510 <go+0x448>
      int pid = fork();
     4b0:	00001097          	auipc	ra,0x1
     4b4:	f2c080e7          	jalr	-212(ra) # 13dc <fork>
     4b8:	87aa                	mv	a5,a0
     4ba:	faf42a23          	sw	a5,-76(s0)
      if(pid == 0){
     4be:	fb442783          	lw	a5,-76(s0)
     4c2:	2781                	sext.w	a5,a5
     4c4:	ef91                	bnez	a5,4e0 <go+0x418>
        fork();
     4c6:	00001097          	auipc	ra,0x1
     4ca:	f16080e7          	jalr	-234(ra) # 13dc <fork>
        fork();
     4ce:	00001097          	auipc	ra,0x1
     4d2:	f0e080e7          	jalr	-242(ra) # 13dc <fork>
        exit(0);
     4d6:	4501                	li	a0,0
     4d8:	00001097          	auipc	ra,0x1
     4dc:	f0c080e7          	jalr	-244(ra) # 13e4 <exit>
      } else if(pid < 0){
     4e0:	fb442783          	lw	a5,-76(s0)
     4e4:	2781                	sext.w	a5,a5
     4e6:	0007df63          	bgez	a5,504 <go+0x43c>
        printf("grind: fork failed\n");
     4ea:	00002517          	auipc	a0,0x2
     4ee:	87650513          	addi	a0,a0,-1930 # 1d60 <malloc+0x24c>
     4f2:	00001097          	auipc	ra,0x1
     4f6:	430080e7          	jalr	1072(ra) # 1922 <printf>
        exit(1);
     4fa:	4505                	li	a0,1
     4fc:	00001097          	auipc	ra,0x1
     500:	ee8080e7          	jalr	-280(ra) # 13e4 <exit>
      }
      wait(0);
     504:	4501                	li	a0,0
     506:	00001097          	auipc	ra,0x1
     50a:	ee6080e7          	jalr	-282(ra) # 13ec <wait>
     50e:	b13d                	j	13c <go+0x74>
    } else if(what == 15){
     510:	fd442783          	lw	a5,-44(s0)
     514:	0007871b          	sext.w	a4,a5
     518:	47bd                	li	a5,15
     51a:	00f71a63          	bne	a4,a5,52e <go+0x466>
      sbrk(6011);
     51e:	6785                	lui	a5,0x1
     520:	77b78513          	addi	a0,a5,1915 # 177b <vprintf+0x117>
     524:	00001097          	auipc	ra,0x1
     528:	f48080e7          	jalr	-184(ra) # 146c <sbrk>
     52c:	b901                	j	13c <go+0x74>
    } else if(what == 16){
     52e:	fd442783          	lw	a5,-44(s0)
     532:	0007871b          	sext.w	a4,a5
     536:	47c1                	li	a5,16
     538:	02f71c63          	bne	a4,a5,570 <go+0x4a8>
      if(sbrk(0) > break0)
     53c:	4501                	li	a0,0
     53e:	00001097          	auipc	ra,0x1
     542:	f2e080e7          	jalr	-210(ra) # 146c <sbrk>
     546:	872a                	mv	a4,a0
     548:	fd843783          	ld	a5,-40(s0)
     54c:	bee7f8e3          	bgeu	a5,a4,13c <go+0x74>
        sbrk(-(sbrk(0) - break0));
     550:	4501                	li	a0,0
     552:	00001097          	auipc	ra,0x1
     556:	f1a080e7          	jalr	-230(ra) # 146c <sbrk>
     55a:	872a                	mv	a4,a0
     55c:	fd843783          	ld	a5,-40(s0)
     560:	8f99                	sub	a5,a5,a4
     562:	2781                	sext.w	a5,a5
     564:	853e                	mv	a0,a5
     566:	00001097          	auipc	ra,0x1
     56a:	f06080e7          	jalr	-250(ra) # 146c <sbrk>
     56e:	b6f9                	j	13c <go+0x74>
    } else if(what == 17){
     570:	fd442783          	lw	a5,-44(s0)
     574:	0007871b          	sext.w	a4,a5
     578:	47c5                	li	a5,17
     57a:	0af71863          	bne	a4,a5,62a <go+0x562>
      int pid = fork();
     57e:	00001097          	auipc	ra,0x1
     582:	e5e080e7          	jalr	-418(ra) # 13dc <fork>
     586:	87aa                	mv	a5,a0
     588:	faf42c23          	sw	a5,-72(s0)
      if(pid == 0){
     58c:	fb842783          	lw	a5,-72(s0)
     590:	2781                	sext.w	a5,a5
     592:	e795                	bnez	a5,5be <go+0x4f6>
        close(open("a", O_CREATE|O_RDWR));
     594:	20200593          	li	a1,514
     598:	00001517          	auipc	a0,0x1
     59c:	7e050513          	addi	a0,a0,2016 # 1d78 <malloc+0x264>
     5a0:	00001097          	auipc	ra,0x1
     5a4:	e84080e7          	jalr	-380(ra) # 1424 <open>
     5a8:	87aa                	mv	a5,a0
     5aa:	853e                	mv	a0,a5
     5ac:	00001097          	auipc	ra,0x1
     5b0:	e60080e7          	jalr	-416(ra) # 140c <close>
        exit(0);
     5b4:	4501                	li	a0,0
     5b6:	00001097          	auipc	ra,0x1
     5ba:	e2e080e7          	jalr	-466(ra) # 13e4 <exit>
      } else if(pid < 0){
     5be:	fb842783          	lw	a5,-72(s0)
     5c2:	2781                	sext.w	a5,a5
     5c4:	0007df63          	bgez	a5,5e2 <go+0x51a>
        printf("grind: fork failed\n");
     5c8:	00001517          	auipc	a0,0x1
     5cc:	79850513          	addi	a0,a0,1944 # 1d60 <malloc+0x24c>
     5d0:	00001097          	auipc	ra,0x1
     5d4:	352080e7          	jalr	850(ra) # 1922 <printf>
        exit(1);
     5d8:	4505                	li	a0,1
     5da:	00001097          	auipc	ra,0x1
     5de:	e0a080e7          	jalr	-502(ra) # 13e4 <exit>
      }
      if(chdir("../grindir/..") != 0){
     5e2:	00001517          	auipc	a0,0x1
     5e6:	79e50513          	addi	a0,a0,1950 # 1d80 <malloc+0x26c>
     5ea:	00001097          	auipc	ra,0x1
     5ee:	e6a080e7          	jalr	-406(ra) # 1454 <chdir>
     5f2:	87aa                	mv	a5,a0
     5f4:	cf91                	beqz	a5,610 <go+0x548>
        printf("grind: chdir failed\n");
     5f6:	00001517          	auipc	a0,0x1
     5fa:	79a50513          	addi	a0,a0,1946 # 1d90 <malloc+0x27c>
     5fe:	00001097          	auipc	ra,0x1
     602:	324080e7          	jalr	804(ra) # 1922 <printf>
        exit(1);
     606:	4505                	li	a0,1
     608:	00001097          	auipc	ra,0x1
     60c:	ddc080e7          	jalr	-548(ra) # 13e4 <exit>
      }
      kill(pid);
     610:	fb842783          	lw	a5,-72(s0)
     614:	853e                	mv	a0,a5
     616:	00001097          	auipc	ra,0x1
     61a:	dfe080e7          	jalr	-514(ra) # 1414 <kill>
      wait(0);
     61e:	4501                	li	a0,0
     620:	00001097          	auipc	ra,0x1
     624:	dcc080e7          	jalr	-564(ra) # 13ec <wait>
     628:	be11                	j	13c <go+0x74>
    } else if(what == 18){
     62a:	fd442783          	lw	a5,-44(s0)
     62e:	0007871b          	sext.w	a4,a5
     632:	47c9                	li	a5,18
     634:	06f71463          	bne	a4,a5,69c <go+0x5d4>
      int pid = fork();
     638:	00001097          	auipc	ra,0x1
     63c:	da4080e7          	jalr	-604(ra) # 13dc <fork>
     640:	87aa                	mv	a5,a0
     642:	faf42e23          	sw	a5,-68(s0)
      if(pid == 0){
     646:	fbc42783          	lw	a5,-68(s0)
     64a:	2781                	sext.w	a5,a5
     64c:	e385                	bnez	a5,66c <go+0x5a4>
        kill(getpid());
     64e:	00001097          	auipc	ra,0x1
     652:	e16080e7          	jalr	-490(ra) # 1464 <getpid>
     656:	87aa                	mv	a5,a0
     658:	853e                	mv	a0,a5
     65a:	00001097          	auipc	ra,0x1
     65e:	dba080e7          	jalr	-582(ra) # 1414 <kill>
        exit(0);
     662:	4501                	li	a0,0
     664:	00001097          	auipc	ra,0x1
     668:	d80080e7          	jalr	-640(ra) # 13e4 <exit>
      } else if(pid < 0){
     66c:	fbc42783          	lw	a5,-68(s0)
     670:	2781                	sext.w	a5,a5
     672:	0007df63          	bgez	a5,690 <go+0x5c8>
        printf("grind: fork failed\n");
     676:	00001517          	auipc	a0,0x1
     67a:	6ea50513          	addi	a0,a0,1770 # 1d60 <malloc+0x24c>
     67e:	00001097          	auipc	ra,0x1
     682:	2a4080e7          	jalr	676(ra) # 1922 <printf>
        exit(1);
     686:	4505                	li	a0,1
     688:	00001097          	auipc	ra,0x1
     68c:	d5c080e7          	jalr	-676(ra) # 13e4 <exit>
      }
      wait(0);
     690:	4501                	li	a0,0
     692:	00001097          	auipc	ra,0x1
     696:	d5a080e7          	jalr	-678(ra) # 13ec <wait>
     69a:	b44d                	j	13c <go+0x74>
    } else if(what == 19){
     69c:	fd442783          	lw	a5,-44(s0)
     6a0:	0007871b          	sext.w	a4,a5
     6a4:	47cd                	li	a5,19
     6a6:	10f71863          	bne	a4,a5,7b6 <go+0x6ee>
      int fds[2];
      if(pipe(fds) < 0){
     6aa:	fa840793          	addi	a5,s0,-88
     6ae:	853e                	mv	a0,a5
     6b0:	00001097          	auipc	ra,0x1
     6b4:	d44080e7          	jalr	-700(ra) # 13f4 <pipe>
     6b8:	87aa                	mv	a5,a0
     6ba:	0007df63          	bgez	a5,6d8 <go+0x610>
        printf("grind: pipe failed\n");
     6be:	00001517          	auipc	a0,0x1
     6c2:	6ea50513          	addi	a0,a0,1770 # 1da8 <malloc+0x294>
     6c6:	00001097          	auipc	ra,0x1
     6ca:	25c080e7          	jalr	604(ra) # 1922 <printf>
        exit(1);
     6ce:	4505                	li	a0,1
     6d0:	00001097          	auipc	ra,0x1
     6d4:	d14080e7          	jalr	-748(ra) # 13e4 <exit>
      }
      int pid = fork();
     6d8:	00001097          	auipc	ra,0x1
     6dc:	d04080e7          	jalr	-764(ra) # 13dc <fork>
     6e0:	87aa                	mv	a5,a0
     6e2:	fcf42023          	sw	a5,-64(s0)
      if(pid == 0){
     6e6:	fc042783          	lw	a5,-64(s0)
     6ea:	2781                	sext.w	a5,a5
     6ec:	efbd                	bnez	a5,76a <go+0x6a2>
        fork();
     6ee:	00001097          	auipc	ra,0x1
     6f2:	cee080e7          	jalr	-786(ra) # 13dc <fork>
        fork();
     6f6:	00001097          	auipc	ra,0x1
     6fa:	ce6080e7          	jalr	-794(ra) # 13dc <fork>
        if(write(fds[1], "x", 1) != 1)
     6fe:	fac42783          	lw	a5,-84(s0)
     702:	4605                	li	a2,1
     704:	00001597          	auipc	a1,0x1
     708:	6bc58593          	addi	a1,a1,1724 # 1dc0 <malloc+0x2ac>
     70c:	853e                	mv	a0,a5
     70e:	00001097          	auipc	ra,0x1
     712:	cf6080e7          	jalr	-778(ra) # 1404 <write>
     716:	87aa                	mv	a5,a0
     718:	873e                	mv	a4,a5
     71a:	4785                	li	a5,1
     71c:	00f70a63          	beq	a4,a5,730 <go+0x668>
          printf("grind: pipe write failed\n");
     720:	00001517          	auipc	a0,0x1
     724:	6a850513          	addi	a0,a0,1704 # 1dc8 <malloc+0x2b4>
     728:	00001097          	auipc	ra,0x1
     72c:	1fa080e7          	jalr	506(ra) # 1922 <printf>
        char c;
        if(read(fds[0], &c, 1) != 1)
     730:	fa842783          	lw	a5,-88(s0)
     734:	fa740713          	addi	a4,s0,-89
     738:	4605                	li	a2,1
     73a:	85ba                	mv	a1,a4
     73c:	853e                	mv	a0,a5
     73e:	00001097          	auipc	ra,0x1
     742:	cbe080e7          	jalr	-834(ra) # 13fc <read>
     746:	87aa                	mv	a5,a0
     748:	873e                	mv	a4,a5
     74a:	4785                	li	a5,1
     74c:	00f70a63          	beq	a4,a5,760 <go+0x698>
          printf("grind: pipe read failed\n");
     750:	00001517          	auipc	a0,0x1
     754:	69850513          	addi	a0,a0,1688 # 1de8 <malloc+0x2d4>
     758:	00001097          	auipc	ra,0x1
     75c:	1ca080e7          	jalr	458(ra) # 1922 <printf>
        exit(0);
     760:	4501                	li	a0,0
     762:	00001097          	auipc	ra,0x1
     766:	c82080e7          	jalr	-894(ra) # 13e4 <exit>
      } else if(pid < 0){
     76a:	fc042783          	lw	a5,-64(s0)
     76e:	2781                	sext.w	a5,a5
     770:	0007df63          	bgez	a5,78e <go+0x6c6>
        printf("grind: fork failed\n");
     774:	00001517          	auipc	a0,0x1
     778:	5ec50513          	addi	a0,a0,1516 # 1d60 <malloc+0x24c>
     77c:	00001097          	auipc	ra,0x1
     780:	1a6080e7          	jalr	422(ra) # 1922 <printf>
        exit(1);
     784:	4505                	li	a0,1
     786:	00001097          	auipc	ra,0x1
     78a:	c5e080e7          	jalr	-930(ra) # 13e4 <exit>
      }
      close(fds[0]);
     78e:	fa842783          	lw	a5,-88(s0)
     792:	853e                	mv	a0,a5
     794:	00001097          	auipc	ra,0x1
     798:	c78080e7          	jalr	-904(ra) # 140c <close>
      close(fds[1]);
     79c:	fac42783          	lw	a5,-84(s0)
     7a0:	853e                	mv	a0,a5
     7a2:	00001097          	auipc	ra,0x1
     7a6:	c6a080e7          	jalr	-918(ra) # 140c <close>
      wait(0);
     7aa:	4501                	li	a0,0
     7ac:	00001097          	auipc	ra,0x1
     7b0:	c40080e7          	jalr	-960(ra) # 13ec <wait>
     7b4:	b261                	j	13c <go+0x74>
    } else if(what == 20){
     7b6:	fd442783          	lw	a5,-44(s0)
     7ba:	0007871b          	sext.w	a4,a5
     7be:	47d1                	li	a5,20
     7c0:	0af71f63          	bne	a4,a5,87e <go+0x7b6>
      int pid = fork();
     7c4:	00001097          	auipc	ra,0x1
     7c8:	c18080e7          	jalr	-1000(ra) # 13dc <fork>
     7cc:	87aa                	mv	a5,a0
     7ce:	fcf42223          	sw	a5,-60(s0)
      if(pid == 0){
     7d2:	fc442783          	lw	a5,-60(s0)
     7d6:	2781                	sext.w	a5,a5
     7d8:	ebbd                	bnez	a5,84e <go+0x786>
        unlink("a");
     7da:	00001517          	auipc	a0,0x1
     7de:	59e50513          	addi	a0,a0,1438 # 1d78 <malloc+0x264>
     7e2:	00001097          	auipc	ra,0x1
     7e6:	c52080e7          	jalr	-942(ra) # 1434 <unlink>
        mkdir("a");
     7ea:	00001517          	auipc	a0,0x1
     7ee:	58e50513          	addi	a0,a0,1422 # 1d78 <malloc+0x264>
     7f2:	00001097          	auipc	ra,0x1
     7f6:	c5a080e7          	jalr	-934(ra) # 144c <mkdir>
        chdir("a");
     7fa:	00001517          	auipc	a0,0x1
     7fe:	57e50513          	addi	a0,a0,1406 # 1d78 <malloc+0x264>
     802:	00001097          	auipc	ra,0x1
     806:	c52080e7          	jalr	-942(ra) # 1454 <chdir>
        unlink("../a");
     80a:	00001517          	auipc	a0,0x1
     80e:	5fe50513          	addi	a0,a0,1534 # 1e08 <malloc+0x2f4>
     812:	00001097          	auipc	ra,0x1
     816:	c22080e7          	jalr	-990(ra) # 1434 <unlink>
        fd = open("x", O_CREATE|O_RDWR);
     81a:	20200593          	li	a1,514
     81e:	00001517          	auipc	a0,0x1
     822:	5a250513          	addi	a0,a0,1442 # 1dc0 <malloc+0x2ac>
     826:	00001097          	auipc	ra,0x1
     82a:	bfe080e7          	jalr	-1026(ra) # 1424 <open>
     82e:	87aa                	mv	a5,a0
     830:	fef42623          	sw	a5,-20(s0)
        unlink("x");
     834:	00001517          	auipc	a0,0x1
     838:	58c50513          	addi	a0,a0,1420 # 1dc0 <malloc+0x2ac>
     83c:	00001097          	auipc	ra,0x1
     840:	bf8080e7          	jalr	-1032(ra) # 1434 <unlink>
        exit(0);
     844:	4501                	li	a0,0
     846:	00001097          	auipc	ra,0x1
     84a:	b9e080e7          	jalr	-1122(ra) # 13e4 <exit>
      } else if(pid < 0){
     84e:	fc442783          	lw	a5,-60(s0)
     852:	2781                	sext.w	a5,a5
     854:	0007df63          	bgez	a5,872 <go+0x7aa>
        printf("grind: fork failed\n");
     858:	00001517          	auipc	a0,0x1
     85c:	50850513          	addi	a0,a0,1288 # 1d60 <malloc+0x24c>
     860:	00001097          	auipc	ra,0x1
     864:	0c2080e7          	jalr	194(ra) # 1922 <printf>
        exit(1);
     868:	4505                	li	a0,1
     86a:	00001097          	auipc	ra,0x1
     86e:	b7a080e7          	jalr	-1158(ra) # 13e4 <exit>
      }
      wait(0);
     872:	4501                	li	a0,0
     874:	00001097          	auipc	ra,0x1
     878:	b78080e7          	jalr	-1160(ra) # 13ec <wait>
     87c:	b0c1                	j	13c <go+0x74>
    } else if(what == 21){
     87e:	fd442783          	lw	a5,-44(s0)
     882:	0007871b          	sext.w	a4,a5
     886:	47d5                	li	a5,21
     888:	12f71e63          	bne	a4,a5,9c4 <go+0x8fc>
      unlink("c");
     88c:	00001517          	auipc	a0,0x1
     890:	58450513          	addi	a0,a0,1412 # 1e10 <malloc+0x2fc>
     894:	00001097          	auipc	ra,0x1
     898:	ba0080e7          	jalr	-1120(ra) # 1434 <unlink>
      // should always succeed. check that there are free i-nodes,
      // file descriptors, blocks.
      int fd1 = open("c", O_CREATE|O_RDWR);
     89c:	20200593          	li	a1,514
     8a0:	00001517          	auipc	a0,0x1
     8a4:	57050513          	addi	a0,a0,1392 # 1e10 <malloc+0x2fc>
     8a8:	00001097          	auipc	ra,0x1
     8ac:	b7c080e7          	jalr	-1156(ra) # 1424 <open>
     8b0:	87aa                	mv	a5,a0
     8b2:	fcf42423          	sw	a5,-56(s0)
      if(fd1 < 0){
     8b6:	fc842783          	lw	a5,-56(s0)
     8ba:	2781                	sext.w	a5,a5
     8bc:	0007df63          	bgez	a5,8da <go+0x812>
        printf("grind: create c failed\n");
     8c0:	00001517          	auipc	a0,0x1
     8c4:	55850513          	addi	a0,a0,1368 # 1e18 <malloc+0x304>
     8c8:	00001097          	auipc	ra,0x1
     8cc:	05a080e7          	jalr	90(ra) # 1922 <printf>
        exit(1);
     8d0:	4505                	li	a0,1
     8d2:	00001097          	auipc	ra,0x1
     8d6:	b12080e7          	jalr	-1262(ra) # 13e4 <exit>
      }
      if(write(fd1, "x", 1) != 1){
     8da:	fc842783          	lw	a5,-56(s0)
     8de:	4605                	li	a2,1
     8e0:	00001597          	auipc	a1,0x1
     8e4:	4e058593          	addi	a1,a1,1248 # 1dc0 <malloc+0x2ac>
     8e8:	853e                	mv	a0,a5
     8ea:	00001097          	auipc	ra,0x1
     8ee:	b1a080e7          	jalr	-1254(ra) # 1404 <write>
     8f2:	87aa                	mv	a5,a0
     8f4:	873e                	mv	a4,a5
     8f6:	4785                	li	a5,1
     8f8:	00f70f63          	beq	a4,a5,916 <go+0x84e>
        printf("grind: write c failed\n");
     8fc:	00001517          	auipc	a0,0x1
     900:	53450513          	addi	a0,a0,1332 # 1e30 <malloc+0x31c>
     904:	00001097          	auipc	ra,0x1
     908:	01e080e7          	jalr	30(ra) # 1922 <printf>
        exit(1);
     90c:	4505                	li	a0,1
     90e:	00001097          	auipc	ra,0x1
     912:	ad6080e7          	jalr	-1322(ra) # 13e4 <exit>
      }
      struct stat st;
      if(fstat(fd1, &st) != 0){
     916:	f8840713          	addi	a4,s0,-120
     91a:	fc842783          	lw	a5,-56(s0)
     91e:	85ba                	mv	a1,a4
     920:	853e                	mv	a0,a5
     922:	00001097          	auipc	ra,0x1
     926:	b1a080e7          	jalr	-1254(ra) # 143c <fstat>
     92a:	87aa                	mv	a5,a0
     92c:	cf91                	beqz	a5,948 <go+0x880>
        printf("grind: fstat failed\n");
     92e:	00001517          	auipc	a0,0x1
     932:	51a50513          	addi	a0,a0,1306 # 1e48 <malloc+0x334>
     936:	00001097          	auipc	ra,0x1
     93a:	fec080e7          	jalr	-20(ra) # 1922 <printf>
        exit(1);
     93e:	4505                	li	a0,1
     940:	00001097          	auipc	ra,0x1
     944:	aa4080e7          	jalr	-1372(ra) # 13e4 <exit>
      }
      if(st.size != 1){
     948:	f9843703          	ld	a4,-104(s0)
     94c:	4785                	li	a5,1
     94e:	02f70363          	beq	a4,a5,974 <go+0x8ac>
        printf("grind: fstat reports wrong size %d\n", (int)st.size);
     952:	f9843783          	ld	a5,-104(s0)
     956:	2781                	sext.w	a5,a5
     958:	85be                	mv	a1,a5
     95a:	00001517          	auipc	a0,0x1
     95e:	50650513          	addi	a0,a0,1286 # 1e60 <malloc+0x34c>
     962:	00001097          	auipc	ra,0x1
     966:	fc0080e7          	jalr	-64(ra) # 1922 <printf>
        exit(1);
     96a:	4505                	li	a0,1
     96c:	00001097          	auipc	ra,0x1
     970:	a78080e7          	jalr	-1416(ra) # 13e4 <exit>
      }
      if(st.ino > 200){
     974:	f8c42783          	lw	a5,-116(s0)
     978:	873e                	mv	a4,a5
     97a:	0c800793          	li	a5,200
     97e:	02e7f263          	bgeu	a5,a4,9a2 <go+0x8da>
        printf("grind: fstat reports crazy i-number %d\n", st.ino);
     982:	f8c42783          	lw	a5,-116(s0)
     986:	85be                	mv	a1,a5
     988:	00001517          	auipc	a0,0x1
     98c:	50050513          	addi	a0,a0,1280 # 1e88 <malloc+0x374>
     990:	00001097          	auipc	ra,0x1
     994:	f92080e7          	jalr	-110(ra) # 1922 <printf>
        exit(1);
     998:	4505                	li	a0,1
     99a:	00001097          	auipc	ra,0x1
     99e:	a4a080e7          	jalr	-1462(ra) # 13e4 <exit>
      }
      close(fd1);
     9a2:	fc842783          	lw	a5,-56(s0)
     9a6:	853e                	mv	a0,a5
     9a8:	00001097          	auipc	ra,0x1
     9ac:	a64080e7          	jalr	-1436(ra) # 140c <close>
      unlink("c");
     9b0:	00001517          	auipc	a0,0x1
     9b4:	46050513          	addi	a0,a0,1120 # 1e10 <malloc+0x2fc>
     9b8:	00001097          	auipc	ra,0x1
     9bc:	a7c080e7          	jalr	-1412(ra) # 1434 <unlink>
     9c0:	f7cff06f          	j	13c <go+0x74>
    } else if(what == 22){
     9c4:	fd442783          	lw	a5,-44(s0)
     9c8:	0007871b          	sext.w	a4,a5
     9cc:	47d9                	li	a5,22
     9ce:	f6f71763          	bne	a4,a5,13c <go+0x74>
      // echo hi | cat
      int aa[2], bb[2];
      if(pipe(aa) < 0){
     9d2:	f8040793          	addi	a5,s0,-128
     9d6:	853e                	mv	a0,a5
     9d8:	00001097          	auipc	ra,0x1
     9dc:	a1c080e7          	jalr	-1508(ra) # 13f4 <pipe>
     9e0:	87aa                	mv	a5,a0
     9e2:	0207d063          	bgez	a5,a02 <go+0x93a>
        fprintf(2, "grind: pipe failed\n");
     9e6:	00001597          	auipc	a1,0x1
     9ea:	3c258593          	addi	a1,a1,962 # 1da8 <malloc+0x294>
     9ee:	4509                	li	a0,2
     9f0:	00001097          	auipc	ra,0x1
     9f4:	eda080e7          	jalr	-294(ra) # 18ca <fprintf>
        exit(1);
     9f8:	4505                	li	a0,1
     9fa:	00001097          	auipc	ra,0x1
     9fe:	9ea080e7          	jalr	-1558(ra) # 13e4 <exit>
      }
      if(pipe(bb) < 0){
     a02:	f7840793          	addi	a5,s0,-136
     a06:	853e                	mv	a0,a5
     a08:	00001097          	auipc	ra,0x1
     a0c:	9ec080e7          	jalr	-1556(ra) # 13f4 <pipe>
     a10:	87aa                	mv	a5,a0
     a12:	0207d063          	bgez	a5,a32 <go+0x96a>
        fprintf(2, "grind: pipe failed\n");
     a16:	00001597          	auipc	a1,0x1
     a1a:	39258593          	addi	a1,a1,914 # 1da8 <malloc+0x294>
     a1e:	4509                	li	a0,2
     a20:	00001097          	auipc	ra,0x1
     a24:	eaa080e7          	jalr	-342(ra) # 18ca <fprintf>
        exit(1);
     a28:	4505                	li	a0,1
     a2a:	00001097          	auipc	ra,0x1
     a2e:	9ba080e7          	jalr	-1606(ra) # 13e4 <exit>
      }
      int pid1 = fork();
     a32:	00001097          	auipc	ra,0x1
     a36:	9aa080e7          	jalr	-1622(ra) # 13dc <fork>
     a3a:	87aa                	mv	a5,a0
     a3c:	fcf42823          	sw	a5,-48(s0)
      if(pid1 == 0){
     a40:	fd042783          	lw	a5,-48(s0)
     a44:	2781                	sext.w	a5,a5
     a46:	e3f9                	bnez	a5,b0c <go+0xa44>
        close(bb[0]);
     a48:	f7842783          	lw	a5,-136(s0)
     a4c:	853e                	mv	a0,a5
     a4e:	00001097          	auipc	ra,0x1
     a52:	9be080e7          	jalr	-1602(ra) # 140c <close>
        close(bb[1]);
     a56:	f7c42783          	lw	a5,-132(s0)
     a5a:	853e                	mv	a0,a5
     a5c:	00001097          	auipc	ra,0x1
     a60:	9b0080e7          	jalr	-1616(ra) # 140c <close>
        close(aa[0]);
     a64:	f8042783          	lw	a5,-128(s0)
     a68:	853e                	mv	a0,a5
     a6a:	00001097          	auipc	ra,0x1
     a6e:	9a2080e7          	jalr	-1630(ra) # 140c <close>
        close(1);
     a72:	4505                	li	a0,1
     a74:	00001097          	auipc	ra,0x1
     a78:	998080e7          	jalr	-1640(ra) # 140c <close>
        if(dup(aa[1]) != 1){
     a7c:	f8442783          	lw	a5,-124(s0)
     a80:	853e                	mv	a0,a5
     a82:	00001097          	auipc	ra,0x1
     a86:	9da080e7          	jalr	-1574(ra) # 145c <dup>
     a8a:	87aa                	mv	a5,a0
     a8c:	873e                	mv	a4,a5
     a8e:	4785                	li	a5,1
     a90:	02f70063          	beq	a4,a5,ab0 <go+0x9e8>
          fprintf(2, "grind: dup failed\n");
     a94:	00001597          	auipc	a1,0x1
     a98:	41c58593          	addi	a1,a1,1052 # 1eb0 <malloc+0x39c>
     a9c:	4509                	li	a0,2
     a9e:	00001097          	auipc	ra,0x1
     aa2:	e2c080e7          	jalr	-468(ra) # 18ca <fprintf>
          exit(1);
     aa6:	4505                	li	a0,1
     aa8:	00001097          	auipc	ra,0x1
     aac:	93c080e7          	jalr	-1732(ra) # 13e4 <exit>
        }
        close(aa[1]);
     ab0:	f8442783          	lw	a5,-124(s0)
     ab4:	853e                	mv	a0,a5
     ab6:	00001097          	auipc	ra,0x1
     aba:	956080e7          	jalr	-1706(ra) # 140c <close>
        char *args[3] = { "echo", "hi", 0 };
     abe:	00001797          	auipc	a5,0x1
     ac2:	40a78793          	addi	a5,a5,1034 # 1ec8 <malloc+0x3b4>
     ac6:	f4f43823          	sd	a5,-176(s0)
     aca:	00001797          	auipc	a5,0x1
     ace:	40678793          	addi	a5,a5,1030 # 1ed0 <malloc+0x3bc>
     ad2:	f4f43c23          	sd	a5,-168(s0)
     ad6:	f6043023          	sd	zero,-160(s0)
        exec("grindir/../echo", args);
     ada:	f5040793          	addi	a5,s0,-176
     ade:	85be                	mv	a1,a5
     ae0:	00001517          	auipc	a0,0x1
     ae4:	3f850513          	addi	a0,a0,1016 # 1ed8 <malloc+0x3c4>
     ae8:	00001097          	auipc	ra,0x1
     aec:	934080e7          	jalr	-1740(ra) # 141c <exec>
        fprintf(2, "grind: echo: not found\n");
     af0:	00001597          	auipc	a1,0x1
     af4:	3f858593          	addi	a1,a1,1016 # 1ee8 <malloc+0x3d4>
     af8:	4509                	li	a0,2
     afa:	00001097          	auipc	ra,0x1
     afe:	dd0080e7          	jalr	-560(ra) # 18ca <fprintf>
        exit(2);
     b02:	4509                	li	a0,2
     b04:	00001097          	auipc	ra,0x1
     b08:	8e0080e7          	jalr	-1824(ra) # 13e4 <exit>
      } else if(pid1 < 0){
     b0c:	fd042783          	lw	a5,-48(s0)
     b10:	2781                	sext.w	a5,a5
     b12:	0207d063          	bgez	a5,b32 <go+0xa6a>
        fprintf(2, "grind: fork failed\n");
     b16:	00001597          	auipc	a1,0x1
     b1a:	24a58593          	addi	a1,a1,586 # 1d60 <malloc+0x24c>
     b1e:	4509                	li	a0,2
     b20:	00001097          	auipc	ra,0x1
     b24:	daa080e7          	jalr	-598(ra) # 18ca <fprintf>
        exit(3);
     b28:	450d                	li	a0,3
     b2a:	00001097          	auipc	ra,0x1
     b2e:	8ba080e7          	jalr	-1862(ra) # 13e4 <exit>
      }
      int pid2 = fork();
     b32:	00001097          	auipc	ra,0x1
     b36:	8aa080e7          	jalr	-1878(ra) # 13dc <fork>
     b3a:	87aa                	mv	a5,a0
     b3c:	fcf42623          	sw	a5,-52(s0)
      if(pid2 == 0){
     b40:	fcc42783          	lw	a5,-52(s0)
     b44:	2781                	sext.w	a5,a5
     b46:	ebed                	bnez	a5,c38 <go+0xb70>
        close(aa[1]);
     b48:	f8442783          	lw	a5,-124(s0)
     b4c:	853e                	mv	a0,a5
     b4e:	00001097          	auipc	ra,0x1
     b52:	8be080e7          	jalr	-1858(ra) # 140c <close>
        close(bb[0]);
     b56:	f7842783          	lw	a5,-136(s0)
     b5a:	853e                	mv	a0,a5
     b5c:	00001097          	auipc	ra,0x1
     b60:	8b0080e7          	jalr	-1872(ra) # 140c <close>
        close(0);
     b64:	4501                	li	a0,0
     b66:	00001097          	auipc	ra,0x1
     b6a:	8a6080e7          	jalr	-1882(ra) # 140c <close>
        if(dup(aa[0]) != 0){
     b6e:	f8042783          	lw	a5,-128(s0)
     b72:	853e                	mv	a0,a5
     b74:	00001097          	auipc	ra,0x1
     b78:	8e8080e7          	jalr	-1816(ra) # 145c <dup>
     b7c:	87aa                	mv	a5,a0
     b7e:	cf99                	beqz	a5,b9c <go+0xad4>
          fprintf(2, "grind: dup failed\n");
     b80:	00001597          	auipc	a1,0x1
     b84:	33058593          	addi	a1,a1,816 # 1eb0 <malloc+0x39c>
     b88:	4509                	li	a0,2
     b8a:	00001097          	auipc	ra,0x1
     b8e:	d40080e7          	jalr	-704(ra) # 18ca <fprintf>
          exit(4);
     b92:	4511                	li	a0,4
     b94:	00001097          	auipc	ra,0x1
     b98:	850080e7          	jalr	-1968(ra) # 13e4 <exit>
        }
        close(aa[0]);
     b9c:	f8042783          	lw	a5,-128(s0)
     ba0:	853e                	mv	a0,a5
     ba2:	00001097          	auipc	ra,0x1
     ba6:	86a080e7          	jalr	-1942(ra) # 140c <close>
        close(1);
     baa:	4505                	li	a0,1
     bac:	00001097          	auipc	ra,0x1
     bb0:	860080e7          	jalr	-1952(ra) # 140c <close>
        if(dup(bb[1]) != 1){
     bb4:	f7c42783          	lw	a5,-132(s0)
     bb8:	853e                	mv	a0,a5
     bba:	00001097          	auipc	ra,0x1
     bbe:	8a2080e7          	jalr	-1886(ra) # 145c <dup>
     bc2:	87aa                	mv	a5,a0
     bc4:	873e                	mv	a4,a5
     bc6:	4785                	li	a5,1
     bc8:	02f70063          	beq	a4,a5,be8 <go+0xb20>
          fprintf(2, "grind: dup failed\n");
     bcc:	00001597          	auipc	a1,0x1
     bd0:	2e458593          	addi	a1,a1,740 # 1eb0 <malloc+0x39c>
     bd4:	4509                	li	a0,2
     bd6:	00001097          	auipc	ra,0x1
     bda:	cf4080e7          	jalr	-780(ra) # 18ca <fprintf>
          exit(5);
     bde:	4515                	li	a0,5
     be0:	00001097          	auipc	ra,0x1
     be4:	804080e7          	jalr	-2044(ra) # 13e4 <exit>
        }
        close(bb[1]);
     be8:	f7c42783          	lw	a5,-132(s0)
     bec:	853e                	mv	a0,a5
     bee:	00001097          	auipc	ra,0x1
     bf2:	81e080e7          	jalr	-2018(ra) # 140c <close>
        char *args[2] = { "cat", 0 };
     bf6:	00001797          	auipc	a5,0x1
     bfa:	30a78793          	addi	a5,a5,778 # 1f00 <malloc+0x3ec>
     bfe:	f4f43023          	sd	a5,-192(s0)
     c02:	f4043423          	sd	zero,-184(s0)
        exec("/cat", args);
     c06:	f4040793          	addi	a5,s0,-192
     c0a:	85be                	mv	a1,a5
     c0c:	00001517          	auipc	a0,0x1
     c10:	2fc50513          	addi	a0,a0,764 # 1f08 <malloc+0x3f4>
     c14:	00001097          	auipc	ra,0x1
     c18:	808080e7          	jalr	-2040(ra) # 141c <exec>
        fprintf(2, "grind: cat: not found\n");
     c1c:	00001597          	auipc	a1,0x1
     c20:	2f458593          	addi	a1,a1,756 # 1f10 <malloc+0x3fc>
     c24:	4509                	li	a0,2
     c26:	00001097          	auipc	ra,0x1
     c2a:	ca4080e7          	jalr	-860(ra) # 18ca <fprintf>
        exit(6);
     c2e:	4519                	li	a0,6
     c30:	00000097          	auipc	ra,0x0
     c34:	7b4080e7          	jalr	1972(ra) # 13e4 <exit>
      } else if(pid2 < 0){
     c38:	fcc42783          	lw	a5,-52(s0)
     c3c:	2781                	sext.w	a5,a5
     c3e:	0207d063          	bgez	a5,c5e <go+0xb96>
        fprintf(2, "grind: fork failed\n");
     c42:	00001597          	auipc	a1,0x1
     c46:	11e58593          	addi	a1,a1,286 # 1d60 <malloc+0x24c>
     c4a:	4509                	li	a0,2
     c4c:	00001097          	auipc	ra,0x1
     c50:	c7e080e7          	jalr	-898(ra) # 18ca <fprintf>
        exit(7);
     c54:	451d                	li	a0,7
     c56:	00000097          	auipc	ra,0x0
     c5a:	78e080e7          	jalr	1934(ra) # 13e4 <exit>
      }
      close(aa[0]);
     c5e:	f8042783          	lw	a5,-128(s0)
     c62:	853e                	mv	a0,a5
     c64:	00000097          	auipc	ra,0x0
     c68:	7a8080e7          	jalr	1960(ra) # 140c <close>
      close(aa[1]);
     c6c:	f8442783          	lw	a5,-124(s0)
     c70:	853e                	mv	a0,a5
     c72:	00000097          	auipc	ra,0x0
     c76:	79a080e7          	jalr	1946(ra) # 140c <close>
      close(bb[1]);
     c7a:	f7c42783          	lw	a5,-132(s0)
     c7e:	853e                	mv	a0,a5
     c80:	00000097          	auipc	ra,0x0
     c84:	78c080e7          	jalr	1932(ra) # 140c <close>
      char buf[4] = { 0, 0, 0, 0 };
     c88:	f6042823          	sw	zero,-144(s0)
      read(bb[0], buf+0, 1);
     c8c:	f7842783          	lw	a5,-136(s0)
     c90:	f7040713          	addi	a4,s0,-144
     c94:	4605                	li	a2,1
     c96:	85ba                	mv	a1,a4
     c98:	853e                	mv	a0,a5
     c9a:	00000097          	auipc	ra,0x0
     c9e:	762080e7          	jalr	1890(ra) # 13fc <read>
      read(bb[0], buf+1, 1);
     ca2:	f7842703          	lw	a4,-136(s0)
     ca6:	f7040793          	addi	a5,s0,-144
     caa:	0785                	addi	a5,a5,1
     cac:	4605                	li	a2,1
     cae:	85be                	mv	a1,a5
     cb0:	853a                	mv	a0,a4
     cb2:	00000097          	auipc	ra,0x0
     cb6:	74a080e7          	jalr	1866(ra) # 13fc <read>
      read(bb[0], buf+2, 1);
     cba:	f7842703          	lw	a4,-136(s0)
     cbe:	f7040793          	addi	a5,s0,-144
     cc2:	0789                	addi	a5,a5,2
     cc4:	4605                	li	a2,1
     cc6:	85be                	mv	a1,a5
     cc8:	853a                	mv	a0,a4
     cca:	00000097          	auipc	ra,0x0
     cce:	732080e7          	jalr	1842(ra) # 13fc <read>
      close(bb[0]);
     cd2:	f7842783          	lw	a5,-136(s0)
     cd6:	853e                	mv	a0,a5
     cd8:	00000097          	auipc	ra,0x0
     cdc:	734080e7          	jalr	1844(ra) # 140c <close>
      int st1, st2;
      wait(&st1);
     ce0:	f6c40793          	addi	a5,s0,-148
     ce4:	853e                	mv	a0,a5
     ce6:	00000097          	auipc	ra,0x0
     cea:	706080e7          	jalr	1798(ra) # 13ec <wait>
      wait(&st2);
     cee:	f6840793          	addi	a5,s0,-152
     cf2:	853e                	mv	a0,a5
     cf4:	00000097          	auipc	ra,0x0
     cf8:	6f8080e7          	jalr	1784(ra) # 13ec <wait>
      if(st1 != 0 || st2 != 0 || strcmp(buf, "hi\n") != 0){
     cfc:	f6c42783          	lw	a5,-148(s0)
     d00:	e395                	bnez	a5,d24 <go+0xc5c>
     d02:	f6842783          	lw	a5,-152(s0)
     d06:	ef99                	bnez	a5,d24 <go+0xc5c>
     d08:	f7040793          	addi	a5,s0,-144
     d0c:	00001597          	auipc	a1,0x1
     d10:	21c58593          	addi	a1,a1,540 # 1f28 <malloc+0x414>
     d14:	853e                	mv	a0,a5
     d16:	00000097          	auipc	ra,0x0
     d1a:	206080e7          	jalr	518(ra) # f1c <strcmp>
     d1e:	87aa                	mv	a5,a0
     d20:	c0078e63          	beqz	a5,13c <go+0x74>
        printf("grind: exec pipeline failed %d %d \"%s\"\n", st1, st2, buf);
     d24:	f6c42783          	lw	a5,-148(s0)
     d28:	f6842703          	lw	a4,-152(s0)
     d2c:	f7040693          	addi	a3,s0,-144
     d30:	863a                	mv	a2,a4
     d32:	85be                	mv	a1,a5
     d34:	00001517          	auipc	a0,0x1
     d38:	1fc50513          	addi	a0,a0,508 # 1f30 <malloc+0x41c>
     d3c:	00001097          	auipc	ra,0x1
     d40:	be6080e7          	jalr	-1050(ra) # 1922 <printf>
        exit(1);
     d44:	4505                	li	a0,1
     d46:	00000097          	auipc	ra,0x0
     d4a:	69e080e7          	jalr	1694(ra) # 13e4 <exit>

0000000000000d4e <iter>:
  }
}

void
iter()
{
     d4e:	1101                	addi	sp,sp,-32
     d50:	ec06                	sd	ra,24(sp)
     d52:	e822                	sd	s0,16(sp)
     d54:	1000                	addi	s0,sp,32
  unlink("a");
     d56:	00001517          	auipc	a0,0x1
     d5a:	02250513          	addi	a0,a0,34 # 1d78 <malloc+0x264>
     d5e:	00000097          	auipc	ra,0x0
     d62:	6d6080e7          	jalr	1750(ra) # 1434 <unlink>
  unlink("b");
     d66:	00001517          	auipc	a0,0x1
     d6a:	fc250513          	addi	a0,a0,-62 # 1d28 <malloc+0x214>
     d6e:	00000097          	auipc	ra,0x0
     d72:	6c6080e7          	jalr	1734(ra) # 1434 <unlink>
  
  int pid1 = fork();
     d76:	00000097          	auipc	ra,0x0
     d7a:	666080e7          	jalr	1638(ra) # 13dc <fork>
     d7e:	87aa                	mv	a5,a0
     d80:	fef42623          	sw	a5,-20(s0)
  if(pid1 < 0){
     d84:	fec42783          	lw	a5,-20(s0)
     d88:	2781                	sext.w	a5,a5
     d8a:	0007df63          	bgez	a5,da8 <iter+0x5a>
    printf("grind: fork failed\n");
     d8e:	00001517          	auipc	a0,0x1
     d92:	fd250513          	addi	a0,a0,-46 # 1d60 <malloc+0x24c>
     d96:	00001097          	auipc	ra,0x1
     d9a:	b8c080e7          	jalr	-1140(ra) # 1922 <printf>
    exit(1);
     d9e:	4505                	li	a0,1
     da0:	00000097          	auipc	ra,0x0
     da4:	644080e7          	jalr	1604(ra) # 13e4 <exit>
  }
  if(pid1 == 0){
     da8:	fec42783          	lw	a5,-20(s0)
     dac:	2781                	sext.w	a5,a5
     dae:	e38d                	bnez	a5,dd0 <iter+0x82>
    rand_next = 31;
     db0:	00001797          	auipc	a5,0x1
     db4:	1c878793          	addi	a5,a5,456 # 1f78 <rand_next>
     db8:	477d                	li	a4,31
     dba:	e398                	sd	a4,0(a5)
    go(0);
     dbc:	4501                	li	a0,0
     dbe:	fffff097          	auipc	ra,0xfffff
     dc2:	30a080e7          	jalr	778(ra) # c8 <go>
    exit(0);
     dc6:	4501                	li	a0,0
     dc8:	00000097          	auipc	ra,0x0
     dcc:	61c080e7          	jalr	1564(ra) # 13e4 <exit>
  }

  int pid2 = fork();
     dd0:	00000097          	auipc	ra,0x0
     dd4:	60c080e7          	jalr	1548(ra) # 13dc <fork>
     dd8:	87aa                	mv	a5,a0
     dda:	fef42423          	sw	a5,-24(s0)
  if(pid2 < 0){
     dde:	fe842783          	lw	a5,-24(s0)
     de2:	2781                	sext.w	a5,a5
     de4:	0007df63          	bgez	a5,e02 <iter+0xb4>
    printf("grind: fork failed\n");
     de8:	00001517          	auipc	a0,0x1
     dec:	f7850513          	addi	a0,a0,-136 # 1d60 <malloc+0x24c>
     df0:	00001097          	auipc	ra,0x1
     df4:	b32080e7          	jalr	-1230(ra) # 1922 <printf>
    exit(1);
     df8:	4505                	li	a0,1
     dfa:	00000097          	auipc	ra,0x0
     dfe:	5ea080e7          	jalr	1514(ra) # 13e4 <exit>
  }
  if(pid2 == 0){
     e02:	fe842783          	lw	a5,-24(s0)
     e06:	2781                	sext.w	a5,a5
     e08:	e39d                	bnez	a5,e2e <iter+0xe0>
    rand_next = 7177;
     e0a:	00001797          	auipc	a5,0x1
     e0e:	16e78793          	addi	a5,a5,366 # 1f78 <rand_next>
     e12:	6709                	lui	a4,0x2
     e14:	c0970713          	addi	a4,a4,-1015 # 1c09 <malloc+0xf5>
     e18:	e398                	sd	a4,0(a5)
    go(1);
     e1a:	4505                	li	a0,1
     e1c:	fffff097          	auipc	ra,0xfffff
     e20:	2ac080e7          	jalr	684(ra) # c8 <go>
    exit(0);
     e24:	4501                	li	a0,0
     e26:	00000097          	auipc	ra,0x0
     e2a:	5be080e7          	jalr	1470(ra) # 13e4 <exit>
  }

  int st1 = -1;
     e2e:	57fd                	li	a5,-1
     e30:	fef42223          	sw	a5,-28(s0)
  wait(&st1);
     e34:	fe440793          	addi	a5,s0,-28
     e38:	853e                	mv	a0,a5
     e3a:	00000097          	auipc	ra,0x0
     e3e:	5b2080e7          	jalr	1458(ra) # 13ec <wait>
  if(st1 != 0){
     e42:	fe442783          	lw	a5,-28(s0)
     e46:	cf99                	beqz	a5,e64 <iter+0x116>
    kill(pid1);
     e48:	fec42783          	lw	a5,-20(s0)
     e4c:	853e                	mv	a0,a5
     e4e:	00000097          	auipc	ra,0x0
     e52:	5c6080e7          	jalr	1478(ra) # 1414 <kill>
    kill(pid2);
     e56:	fe842783          	lw	a5,-24(s0)
     e5a:	853e                	mv	a0,a5
     e5c:	00000097          	auipc	ra,0x0
     e60:	5b8080e7          	jalr	1464(ra) # 1414 <kill>
  }
  int st2 = -1;
     e64:	57fd                	li	a5,-1
     e66:	fef42023          	sw	a5,-32(s0)
  wait(&st2);
     e6a:	fe040793          	addi	a5,s0,-32
     e6e:	853e                	mv	a0,a5
     e70:	00000097          	auipc	ra,0x0
     e74:	57c080e7          	jalr	1404(ra) # 13ec <wait>

  exit(0);
     e78:	4501                	li	a0,0
     e7a:	00000097          	auipc	ra,0x0
     e7e:	56a080e7          	jalr	1386(ra) # 13e4 <exit>

0000000000000e82 <main>:
}

int
main()
{
     e82:	1101                	addi	sp,sp,-32
     e84:	ec06                	sd	ra,24(sp)
     e86:	e822                	sd	s0,16(sp)
     e88:	1000                	addi	s0,sp,32
  while(1){
    int pid = fork();
     e8a:	00000097          	auipc	ra,0x0
     e8e:	552080e7          	jalr	1362(ra) # 13dc <fork>
     e92:	87aa                	mv	a5,a0
     e94:	fef42623          	sw	a5,-20(s0)
    if(pid == 0){
     e98:	fec42783          	lw	a5,-20(s0)
     e9c:	2781                	sext.w	a5,a5
     e9e:	eb91                	bnez	a5,eb2 <main+0x30>
      iter();
     ea0:	00000097          	auipc	ra,0x0
     ea4:	eae080e7          	jalr	-338(ra) # d4e <iter>
      exit(0);
     ea8:	4501                	li	a0,0
     eaa:	00000097          	auipc	ra,0x0
     eae:	53a080e7          	jalr	1338(ra) # 13e4 <exit>
    }
    if(pid > 0){
     eb2:	fec42783          	lw	a5,-20(s0)
     eb6:	2781                	sext.w	a5,a5
     eb8:	00f05763          	blez	a5,ec6 <main+0x44>
      wait(0);
     ebc:	4501                	li	a0,0
     ebe:	00000097          	auipc	ra,0x0
     ec2:	52e080e7          	jalr	1326(ra) # 13ec <wait>
    }
    sleep(20);
     ec6:	4551                	li	a0,20
     ec8:	00000097          	auipc	ra,0x0
     ecc:	5ac080e7          	jalr	1452(ra) # 1474 <sleep>
  while(1){
     ed0:	bf6d                	j	e8a <main+0x8>

0000000000000ed2 <strcpy>:
#include "kernel/fcntl.h"
#include "user/user.h"

char*
strcpy(char *s, const char *t)
{
     ed2:	7179                	addi	sp,sp,-48
     ed4:	f422                	sd	s0,40(sp)
     ed6:	1800                	addi	s0,sp,48
     ed8:	fca43c23          	sd	a0,-40(s0)
     edc:	fcb43823          	sd	a1,-48(s0)
  char *os;

  os = s;
     ee0:	fd843783          	ld	a5,-40(s0)
     ee4:	fef43423          	sd	a5,-24(s0)
  while((*s++ = *t++) != 0)
     ee8:	0001                	nop
     eea:	fd043703          	ld	a4,-48(s0)
     eee:	00170793          	addi	a5,a4,1
     ef2:	fcf43823          	sd	a5,-48(s0)
     ef6:	fd843783          	ld	a5,-40(s0)
     efa:	00178693          	addi	a3,a5,1
     efe:	fcd43c23          	sd	a3,-40(s0)
     f02:	00074703          	lbu	a4,0(a4)
     f06:	00e78023          	sb	a4,0(a5)
     f0a:	0007c783          	lbu	a5,0(a5)
     f0e:	fff1                	bnez	a5,eea <strcpy+0x18>
    ;
  return os;
     f10:	fe843783          	ld	a5,-24(s0)
}
     f14:	853e                	mv	a0,a5
     f16:	7422                	ld	s0,40(sp)
     f18:	6145                	addi	sp,sp,48
     f1a:	8082                	ret

0000000000000f1c <strcmp>:

int
strcmp(const char *p, const char *q)
{
     f1c:	1101                	addi	sp,sp,-32
     f1e:	ec22                	sd	s0,24(sp)
     f20:	1000                	addi	s0,sp,32
     f22:	fea43423          	sd	a0,-24(s0)
     f26:	feb43023          	sd	a1,-32(s0)
  while(*p && *p == *q)
     f2a:	a819                	j	f40 <strcmp+0x24>
    p++, q++;
     f2c:	fe843783          	ld	a5,-24(s0)
     f30:	0785                	addi	a5,a5,1
     f32:	fef43423          	sd	a5,-24(s0)
     f36:	fe043783          	ld	a5,-32(s0)
     f3a:	0785                	addi	a5,a5,1
     f3c:	fef43023          	sd	a5,-32(s0)
  while(*p && *p == *q)
     f40:	fe843783          	ld	a5,-24(s0)
     f44:	0007c783          	lbu	a5,0(a5)
     f48:	cb99                	beqz	a5,f5e <strcmp+0x42>
     f4a:	fe843783          	ld	a5,-24(s0)
     f4e:	0007c703          	lbu	a4,0(a5)
     f52:	fe043783          	ld	a5,-32(s0)
     f56:	0007c783          	lbu	a5,0(a5)
     f5a:	fcf709e3          	beq	a4,a5,f2c <strcmp+0x10>
  return (uchar)*p - (uchar)*q;
     f5e:	fe843783          	ld	a5,-24(s0)
     f62:	0007c783          	lbu	a5,0(a5)
     f66:	0007871b          	sext.w	a4,a5
     f6a:	fe043783          	ld	a5,-32(s0)
     f6e:	0007c783          	lbu	a5,0(a5)
     f72:	2781                	sext.w	a5,a5
     f74:	40f707bb          	subw	a5,a4,a5
     f78:	2781                	sext.w	a5,a5
}
     f7a:	853e                	mv	a0,a5
     f7c:	6462                	ld	s0,24(sp)
     f7e:	6105                	addi	sp,sp,32
     f80:	8082                	ret

0000000000000f82 <strlen>:

uint
strlen(const char *s)
{
     f82:	7179                	addi	sp,sp,-48
     f84:	f422                	sd	s0,40(sp)
     f86:	1800                	addi	s0,sp,48
     f88:	fca43c23          	sd	a0,-40(s0)
  int n;

  for(n = 0; s[n]; n++)
     f8c:	fe042623          	sw	zero,-20(s0)
     f90:	a031                	j	f9c <strlen+0x1a>
     f92:	fec42783          	lw	a5,-20(s0)
     f96:	2785                	addiw	a5,a5,1
     f98:	fef42623          	sw	a5,-20(s0)
     f9c:	fec42783          	lw	a5,-20(s0)
     fa0:	fd843703          	ld	a4,-40(s0)
     fa4:	97ba                	add	a5,a5,a4
     fa6:	0007c783          	lbu	a5,0(a5)
     faa:	f7e5                	bnez	a5,f92 <strlen+0x10>
    ;
  return n;
     fac:	fec42783          	lw	a5,-20(s0)
}
     fb0:	853e                	mv	a0,a5
     fb2:	7422                	ld	s0,40(sp)
     fb4:	6145                	addi	sp,sp,48
     fb6:	8082                	ret

0000000000000fb8 <memset>:

void*
memset(void *dst, int c, uint n)
{
     fb8:	7179                	addi	sp,sp,-48
     fba:	f422                	sd	s0,40(sp)
     fbc:	1800                	addi	s0,sp,48
     fbe:	fca43c23          	sd	a0,-40(s0)
     fc2:	87ae                	mv	a5,a1
     fc4:	8732                	mv	a4,a2
     fc6:	fcf42a23          	sw	a5,-44(s0)
     fca:	87ba                	mv	a5,a4
     fcc:	fcf42823          	sw	a5,-48(s0)
  char *cdst = (char *) dst;
     fd0:	fd843783          	ld	a5,-40(s0)
     fd4:	fef43023          	sd	a5,-32(s0)
  int i;
  for(i = 0; i < n; i++){
     fd8:	fe042623          	sw	zero,-20(s0)
     fdc:	a00d                	j	ffe <memset+0x46>
    cdst[i] = c;
     fde:	fec42783          	lw	a5,-20(s0)
     fe2:	fe043703          	ld	a4,-32(s0)
     fe6:	97ba                	add	a5,a5,a4
     fe8:	fd442703          	lw	a4,-44(s0)
     fec:	0ff77713          	andi	a4,a4,255
     ff0:	00e78023          	sb	a4,0(a5)
  for(i = 0; i < n; i++){
     ff4:	fec42783          	lw	a5,-20(s0)
     ff8:	2785                	addiw	a5,a5,1
     ffa:	fef42623          	sw	a5,-20(s0)
     ffe:	fec42703          	lw	a4,-20(s0)
    1002:	fd042783          	lw	a5,-48(s0)
    1006:	2781                	sext.w	a5,a5
    1008:	fcf76be3          	bltu	a4,a5,fde <memset+0x26>
  }
  return dst;
    100c:	fd843783          	ld	a5,-40(s0)
}
    1010:	853e                	mv	a0,a5
    1012:	7422                	ld	s0,40(sp)
    1014:	6145                	addi	sp,sp,48
    1016:	8082                	ret

0000000000001018 <strchr>:

char*
strchr(const char *s, char c)
{
    1018:	1101                	addi	sp,sp,-32
    101a:	ec22                	sd	s0,24(sp)
    101c:	1000                	addi	s0,sp,32
    101e:	fea43423          	sd	a0,-24(s0)
    1022:	87ae                	mv	a5,a1
    1024:	fef403a3          	sb	a5,-25(s0)
  for(; *s; s++)
    1028:	a01d                	j	104e <strchr+0x36>
    if(*s == c)
    102a:	fe843783          	ld	a5,-24(s0)
    102e:	0007c703          	lbu	a4,0(a5)
    1032:	fe744783          	lbu	a5,-25(s0)
    1036:	0ff7f793          	andi	a5,a5,255
    103a:	00e79563          	bne	a5,a4,1044 <strchr+0x2c>
      return (char*)s;
    103e:	fe843783          	ld	a5,-24(s0)
    1042:	a821                	j	105a <strchr+0x42>
  for(; *s; s++)
    1044:	fe843783          	ld	a5,-24(s0)
    1048:	0785                	addi	a5,a5,1
    104a:	fef43423          	sd	a5,-24(s0)
    104e:	fe843783          	ld	a5,-24(s0)
    1052:	0007c783          	lbu	a5,0(a5)
    1056:	fbf1                	bnez	a5,102a <strchr+0x12>
  return 0;
    1058:	4781                	li	a5,0
}
    105a:	853e                	mv	a0,a5
    105c:	6462                	ld	s0,24(sp)
    105e:	6105                	addi	sp,sp,32
    1060:	8082                	ret

0000000000001062 <gets>:

char*
gets(char *buf, int max)
{
    1062:	7179                	addi	sp,sp,-48
    1064:	f406                	sd	ra,40(sp)
    1066:	f022                	sd	s0,32(sp)
    1068:	1800                	addi	s0,sp,48
    106a:	fca43c23          	sd	a0,-40(s0)
    106e:	87ae                	mv	a5,a1
    1070:	fcf42a23          	sw	a5,-44(s0)
  int i, cc;
  char c;

  for(i=0; i+1 < max; ){
    1074:	fe042623          	sw	zero,-20(s0)
    1078:	a8a1                	j	10d0 <gets+0x6e>
    cc = read(0, &c, 1);
    107a:	fe740793          	addi	a5,s0,-25
    107e:	4605                	li	a2,1
    1080:	85be                	mv	a1,a5
    1082:	4501                	li	a0,0
    1084:	00000097          	auipc	ra,0x0
    1088:	378080e7          	jalr	888(ra) # 13fc <read>
    108c:	87aa                	mv	a5,a0
    108e:	fef42423          	sw	a5,-24(s0)
    if(cc < 1)
    1092:	fe842783          	lw	a5,-24(s0)
    1096:	2781                	sext.w	a5,a5
    1098:	04f05763          	blez	a5,10e6 <gets+0x84>
      break;
    buf[i++] = c;
    109c:	fec42783          	lw	a5,-20(s0)
    10a0:	0017871b          	addiw	a4,a5,1
    10a4:	fee42623          	sw	a4,-20(s0)
    10a8:	873e                	mv	a4,a5
    10aa:	fd843783          	ld	a5,-40(s0)
    10ae:	97ba                	add	a5,a5,a4
    10b0:	fe744703          	lbu	a4,-25(s0)
    10b4:	00e78023          	sb	a4,0(a5)
    if(c == '\n' || c == '\r')
    10b8:	fe744783          	lbu	a5,-25(s0)
    10bc:	873e                	mv	a4,a5
    10be:	47a9                	li	a5,10
    10c0:	02f70463          	beq	a4,a5,10e8 <gets+0x86>
    10c4:	fe744783          	lbu	a5,-25(s0)
    10c8:	873e                	mv	a4,a5
    10ca:	47b5                	li	a5,13
    10cc:	00f70e63          	beq	a4,a5,10e8 <gets+0x86>
  for(i=0; i+1 < max; ){
    10d0:	fec42783          	lw	a5,-20(s0)
    10d4:	2785                	addiw	a5,a5,1
    10d6:	0007871b          	sext.w	a4,a5
    10da:	fd442783          	lw	a5,-44(s0)
    10de:	2781                	sext.w	a5,a5
    10e0:	f8f74de3          	blt	a4,a5,107a <gets+0x18>
    10e4:	a011                	j	10e8 <gets+0x86>
      break;
    10e6:	0001                	nop
      break;
  }
  buf[i] = '\0';
    10e8:	fec42783          	lw	a5,-20(s0)
    10ec:	fd843703          	ld	a4,-40(s0)
    10f0:	97ba                	add	a5,a5,a4
    10f2:	00078023          	sb	zero,0(a5)
  return buf;
    10f6:	fd843783          	ld	a5,-40(s0)
}
    10fa:	853e                	mv	a0,a5
    10fc:	70a2                	ld	ra,40(sp)
    10fe:	7402                	ld	s0,32(sp)
    1100:	6145                	addi	sp,sp,48
    1102:	8082                	ret

0000000000001104 <stat>:

int
stat(const char *n, struct stat *st)
{
    1104:	7179                	addi	sp,sp,-48
    1106:	f406                	sd	ra,40(sp)
    1108:	f022                	sd	s0,32(sp)
    110a:	1800                	addi	s0,sp,48
    110c:	fca43c23          	sd	a0,-40(s0)
    1110:	fcb43823          	sd	a1,-48(s0)
  int fd;
  int r;

  fd = open(n, O_RDONLY);
    1114:	4581                	li	a1,0
    1116:	fd843503          	ld	a0,-40(s0)
    111a:	00000097          	auipc	ra,0x0
    111e:	30a080e7          	jalr	778(ra) # 1424 <open>
    1122:	87aa                	mv	a5,a0
    1124:	fef42623          	sw	a5,-20(s0)
  if(fd < 0)
    1128:	fec42783          	lw	a5,-20(s0)
    112c:	2781                	sext.w	a5,a5
    112e:	0007d463          	bgez	a5,1136 <stat+0x32>
    return -1;
    1132:	57fd                	li	a5,-1
    1134:	a035                	j	1160 <stat+0x5c>
  r = fstat(fd, st);
    1136:	fec42783          	lw	a5,-20(s0)
    113a:	fd043583          	ld	a1,-48(s0)
    113e:	853e                	mv	a0,a5
    1140:	00000097          	auipc	ra,0x0
    1144:	2fc080e7          	jalr	764(ra) # 143c <fstat>
    1148:	87aa                	mv	a5,a0
    114a:	fef42423          	sw	a5,-24(s0)
  close(fd);
    114e:	fec42783          	lw	a5,-20(s0)
    1152:	853e                	mv	a0,a5
    1154:	00000097          	auipc	ra,0x0
    1158:	2b8080e7          	jalr	696(ra) # 140c <close>
  return r;
    115c:	fe842783          	lw	a5,-24(s0)
}
    1160:	853e                	mv	a0,a5
    1162:	70a2                	ld	ra,40(sp)
    1164:	7402                	ld	s0,32(sp)
    1166:	6145                	addi	sp,sp,48
    1168:	8082                	ret

000000000000116a <atoi>:

int
atoi(const char *s)
{
    116a:	7179                	addi	sp,sp,-48
    116c:	f422                	sd	s0,40(sp)
    116e:	1800                	addi	s0,sp,48
    1170:	fca43c23          	sd	a0,-40(s0)
  int n;

  n = 0;
    1174:	fe042623          	sw	zero,-20(s0)
  while('0' <= *s && *s <= '9')
    1178:	a815                	j	11ac <atoi+0x42>
    n = n*10 + *s++ - '0';
    117a:	fec42703          	lw	a4,-20(s0)
    117e:	87ba                	mv	a5,a4
    1180:	0027979b          	slliw	a5,a5,0x2
    1184:	9fb9                	addw	a5,a5,a4
    1186:	0017979b          	slliw	a5,a5,0x1
    118a:	0007871b          	sext.w	a4,a5
    118e:	fd843783          	ld	a5,-40(s0)
    1192:	00178693          	addi	a3,a5,1
    1196:	fcd43c23          	sd	a3,-40(s0)
    119a:	0007c783          	lbu	a5,0(a5)
    119e:	2781                	sext.w	a5,a5
    11a0:	9fb9                	addw	a5,a5,a4
    11a2:	2781                	sext.w	a5,a5
    11a4:	fd07879b          	addiw	a5,a5,-48
    11a8:	fef42623          	sw	a5,-20(s0)
  while('0' <= *s && *s <= '9')
    11ac:	fd843783          	ld	a5,-40(s0)
    11b0:	0007c783          	lbu	a5,0(a5)
    11b4:	873e                	mv	a4,a5
    11b6:	02f00793          	li	a5,47
    11ba:	00e7fb63          	bgeu	a5,a4,11d0 <atoi+0x66>
    11be:	fd843783          	ld	a5,-40(s0)
    11c2:	0007c783          	lbu	a5,0(a5)
    11c6:	873e                	mv	a4,a5
    11c8:	03900793          	li	a5,57
    11cc:	fae7f7e3          	bgeu	a5,a4,117a <atoi+0x10>
  return n;
    11d0:	fec42783          	lw	a5,-20(s0)
}
    11d4:	853e                	mv	a0,a5
    11d6:	7422                	ld	s0,40(sp)
    11d8:	6145                	addi	sp,sp,48
    11da:	8082                	ret

00000000000011dc <memmove>:

void*
memmove(void *vdst, const void *vsrc, int n)
{
    11dc:	7139                	addi	sp,sp,-64
    11de:	fc22                	sd	s0,56(sp)
    11e0:	0080                	addi	s0,sp,64
    11e2:	fca43c23          	sd	a0,-40(s0)
    11e6:	fcb43823          	sd	a1,-48(s0)
    11ea:	87b2                	mv	a5,a2
    11ec:	fcf42623          	sw	a5,-52(s0)
  char *dst;
  const char *src;

  dst = vdst;
    11f0:	fd843783          	ld	a5,-40(s0)
    11f4:	fef43423          	sd	a5,-24(s0)
  src = vsrc;
    11f8:	fd043783          	ld	a5,-48(s0)
    11fc:	fef43023          	sd	a5,-32(s0)
  if (src > dst) {
    1200:	fe043703          	ld	a4,-32(s0)
    1204:	fe843783          	ld	a5,-24(s0)
    1208:	02e7fc63          	bgeu	a5,a4,1240 <memmove+0x64>
    while(n-- > 0)
    120c:	a00d                	j	122e <memmove+0x52>
      *dst++ = *src++;
    120e:	fe043703          	ld	a4,-32(s0)
    1212:	00170793          	addi	a5,a4,1
    1216:	fef43023          	sd	a5,-32(s0)
    121a:	fe843783          	ld	a5,-24(s0)
    121e:	00178693          	addi	a3,a5,1
    1222:	fed43423          	sd	a3,-24(s0)
    1226:	00074703          	lbu	a4,0(a4)
    122a:	00e78023          	sb	a4,0(a5)
    while(n-- > 0)
    122e:	fcc42783          	lw	a5,-52(s0)
    1232:	fff7871b          	addiw	a4,a5,-1
    1236:	fce42623          	sw	a4,-52(s0)
    123a:	fcf04ae3          	bgtz	a5,120e <memmove+0x32>
    123e:	a891                	j	1292 <memmove+0xb6>
  } else {
    dst += n;
    1240:	fcc42783          	lw	a5,-52(s0)
    1244:	fe843703          	ld	a4,-24(s0)
    1248:	97ba                	add	a5,a5,a4
    124a:	fef43423          	sd	a5,-24(s0)
    src += n;
    124e:	fcc42783          	lw	a5,-52(s0)
    1252:	fe043703          	ld	a4,-32(s0)
    1256:	97ba                	add	a5,a5,a4
    1258:	fef43023          	sd	a5,-32(s0)
    while(n-- > 0)
    125c:	a01d                	j	1282 <memmove+0xa6>
      *--dst = *--src;
    125e:	fe043783          	ld	a5,-32(s0)
    1262:	17fd                	addi	a5,a5,-1
    1264:	fef43023          	sd	a5,-32(s0)
    1268:	fe843783          	ld	a5,-24(s0)
    126c:	17fd                	addi	a5,a5,-1
    126e:	fef43423          	sd	a5,-24(s0)
    1272:	fe043783          	ld	a5,-32(s0)
    1276:	0007c703          	lbu	a4,0(a5)
    127a:	fe843783          	ld	a5,-24(s0)
    127e:	00e78023          	sb	a4,0(a5)
    while(n-- > 0)
    1282:	fcc42783          	lw	a5,-52(s0)
    1286:	fff7871b          	addiw	a4,a5,-1
    128a:	fce42623          	sw	a4,-52(s0)
    128e:	fcf048e3          	bgtz	a5,125e <memmove+0x82>
  }
  return vdst;
    1292:	fd843783          	ld	a5,-40(s0)
}
    1296:	853e                	mv	a0,a5
    1298:	7462                	ld	s0,56(sp)
    129a:	6121                	addi	sp,sp,64
    129c:	8082                	ret

000000000000129e <strconcat>:

void * strconcat(void *vdst, const void *src1, const void *src2){
    129e:	7139                	addi	sp,sp,-64
    12a0:	fc06                	sd	ra,56(sp)
    12a2:	f822                	sd	s0,48(sp)
    12a4:	0080                	addi	s0,sp,64
    12a6:	fca43c23          	sd	a0,-40(s0)
    12aa:	fcb43823          	sd	a1,-48(s0)
    12ae:	fcc43423          	sd	a2,-56(s0)
  int src1Len = strlen(src1);
    12b2:	fd043503          	ld	a0,-48(s0)
    12b6:	00000097          	auipc	ra,0x0
    12ba:	ccc080e7          	jalr	-820(ra) # f82 <strlen>
    12be:	87aa                	mv	a5,a0
    12c0:	2781                	sext.w	a5,a5
    12c2:	fef42623          	sw	a5,-20(s0)
  int src2Len = strlen(src2);
    12c6:	fc843503          	ld	a0,-56(s0)
    12ca:	00000097          	auipc	ra,0x0
    12ce:	cb8080e7          	jalr	-840(ra) # f82 <strlen>
    12d2:	87aa                	mv	a5,a0
    12d4:	2781                	sext.w	a5,a5
    12d6:	fef42423          	sw	a5,-24(s0)
  memmove(vdst, src1, src1Len);
    12da:	fec42783          	lw	a5,-20(s0)
    12de:	863e                	mv	a2,a5
    12e0:	fd043583          	ld	a1,-48(s0)
    12e4:	fd843503          	ld	a0,-40(s0)
    12e8:	00000097          	auipc	ra,0x0
    12ec:	ef4080e7          	jalr	-268(ra) # 11dc <memmove>
  memmove(vdst+src1Len, src2, src2Len+1);
    12f0:	fec42783          	lw	a5,-20(s0)
    12f4:	fd843703          	ld	a4,-40(s0)
    12f8:	973e                	add	a4,a4,a5
    12fa:	fe842783          	lw	a5,-24(s0)
    12fe:	2785                	addiw	a5,a5,1
    1300:	2781                	sext.w	a5,a5
    1302:	863e                	mv	a2,a5
    1304:	fc843583          	ld	a1,-56(s0)
    1308:	853a                	mv	a0,a4
    130a:	00000097          	auipc	ra,0x0
    130e:	ed2080e7          	jalr	-302(ra) # 11dc <memmove>

  return vdst;
    1312:	fd843783          	ld	a5,-40(s0)
}
    1316:	853e                	mv	a0,a5
    1318:	70e2                	ld	ra,56(sp)
    131a:	7442                	ld	s0,48(sp)
    131c:	6121                	addi	sp,sp,64
    131e:	8082                	ret

0000000000001320 <memcmp>:

int
memcmp(const void *s1, const void *s2, uint n)
{
    1320:	7139                	addi	sp,sp,-64
    1322:	fc22                	sd	s0,56(sp)
    1324:	0080                	addi	s0,sp,64
    1326:	fca43c23          	sd	a0,-40(s0)
    132a:	fcb43823          	sd	a1,-48(s0)
    132e:	87b2                	mv	a5,a2
    1330:	fcf42623          	sw	a5,-52(s0)
  const char *p1 = s1, *p2 = s2;
    1334:	fd843783          	ld	a5,-40(s0)
    1338:	fef43423          	sd	a5,-24(s0)
    133c:	fd043783          	ld	a5,-48(s0)
    1340:	fef43023          	sd	a5,-32(s0)
  while (n-- > 0) {
    1344:	a0a1                	j	138c <memcmp+0x6c>
    if (*p1 != *p2) {
    1346:	fe843783          	ld	a5,-24(s0)
    134a:	0007c703          	lbu	a4,0(a5)
    134e:	fe043783          	ld	a5,-32(s0)
    1352:	0007c783          	lbu	a5,0(a5)
    1356:	02f70163          	beq	a4,a5,1378 <memcmp+0x58>
      return *p1 - *p2;
    135a:	fe843783          	ld	a5,-24(s0)
    135e:	0007c783          	lbu	a5,0(a5)
    1362:	0007871b          	sext.w	a4,a5
    1366:	fe043783          	ld	a5,-32(s0)
    136a:	0007c783          	lbu	a5,0(a5)
    136e:	2781                	sext.w	a5,a5
    1370:	40f707bb          	subw	a5,a4,a5
    1374:	2781                	sext.w	a5,a5
    1376:	a01d                	j	139c <memcmp+0x7c>
    }
    p1++;
    1378:	fe843783          	ld	a5,-24(s0)
    137c:	0785                	addi	a5,a5,1
    137e:	fef43423          	sd	a5,-24(s0)
    p2++;
    1382:	fe043783          	ld	a5,-32(s0)
    1386:	0785                	addi	a5,a5,1
    1388:	fef43023          	sd	a5,-32(s0)
  while (n-- > 0) {
    138c:	fcc42783          	lw	a5,-52(s0)
    1390:	fff7871b          	addiw	a4,a5,-1
    1394:	fce42623          	sw	a4,-52(s0)
    1398:	f7dd                	bnez	a5,1346 <memcmp+0x26>
  }
  return 0;
    139a:	4781                	li	a5,0
}
    139c:	853e                	mv	a0,a5
    139e:	7462                	ld	s0,56(sp)
    13a0:	6121                	addi	sp,sp,64
    13a2:	8082                	ret

00000000000013a4 <memcpy>:

void *
memcpy(void *dst, const void *src, uint n)
{
    13a4:	7179                	addi	sp,sp,-48
    13a6:	f406                	sd	ra,40(sp)
    13a8:	f022                	sd	s0,32(sp)
    13aa:	1800                	addi	s0,sp,48
    13ac:	fea43423          	sd	a0,-24(s0)
    13b0:	feb43023          	sd	a1,-32(s0)
    13b4:	87b2                	mv	a5,a2
    13b6:	fcf42e23          	sw	a5,-36(s0)
  return memmove(dst, src, n);
    13ba:	fdc42783          	lw	a5,-36(s0)
    13be:	863e                	mv	a2,a5
    13c0:	fe043583          	ld	a1,-32(s0)
    13c4:	fe843503          	ld	a0,-24(s0)
    13c8:	00000097          	auipc	ra,0x0
    13cc:	e14080e7          	jalr	-492(ra) # 11dc <memmove>
    13d0:	87aa                	mv	a5,a0
}
    13d2:	853e                	mv	a0,a5
    13d4:	70a2                	ld	ra,40(sp)
    13d6:	7402                	ld	s0,32(sp)
    13d8:	6145                	addi	sp,sp,48
    13da:	8082                	ret

00000000000013dc <fork>:
# generated by usys.pl - do not edit
#include "kernel/syscall.h"
.global fork
fork:
 li a7, SYS_fork
    13dc:	4885                	li	a7,1
 ecall
    13de:	00000073          	ecall
 ret
    13e2:	8082                	ret

00000000000013e4 <exit>:
.global exit
exit:
 li a7, SYS_exit
    13e4:	4889                	li	a7,2
 ecall
    13e6:	00000073          	ecall
 ret
    13ea:	8082                	ret

00000000000013ec <wait>:
.global wait
wait:
 li a7, SYS_wait
    13ec:	488d                	li	a7,3
 ecall
    13ee:	00000073          	ecall
 ret
    13f2:	8082                	ret

00000000000013f4 <pipe>:
.global pipe
pipe:
 li a7, SYS_pipe
    13f4:	4891                	li	a7,4
 ecall
    13f6:	00000073          	ecall
 ret
    13fa:	8082                	ret

00000000000013fc <read>:
.global read
read:
 li a7, SYS_read
    13fc:	4895                	li	a7,5
 ecall
    13fe:	00000073          	ecall
 ret
    1402:	8082                	ret

0000000000001404 <write>:
.global write
write:
 li a7, SYS_write
    1404:	48c1                	li	a7,16
 ecall
    1406:	00000073          	ecall
 ret
    140a:	8082                	ret

000000000000140c <close>:
.global close
close:
 li a7, SYS_close
    140c:	48d5                	li	a7,21
 ecall
    140e:	00000073          	ecall
 ret
    1412:	8082                	ret

0000000000001414 <kill>:
.global kill
kill:
 li a7, SYS_kill
    1414:	4899                	li	a7,6
 ecall
    1416:	00000073          	ecall
 ret
    141a:	8082                	ret

000000000000141c <exec>:
.global exec
exec:
 li a7, SYS_exec
    141c:	489d                	li	a7,7
 ecall
    141e:	00000073          	ecall
 ret
    1422:	8082                	ret

0000000000001424 <open>:
.global open
open:
 li a7, SYS_open
    1424:	48bd                	li	a7,15
 ecall
    1426:	00000073          	ecall
 ret
    142a:	8082                	ret

000000000000142c <mknod>:
.global mknod
mknod:
 li a7, SYS_mknod
    142c:	48c5                	li	a7,17
 ecall
    142e:	00000073          	ecall
 ret
    1432:	8082                	ret

0000000000001434 <unlink>:
.global unlink
unlink:
 li a7, SYS_unlink
    1434:	48c9                	li	a7,18
 ecall
    1436:	00000073          	ecall
 ret
    143a:	8082                	ret

000000000000143c <fstat>:
.global fstat
fstat:
 li a7, SYS_fstat
    143c:	48a1                	li	a7,8
 ecall
    143e:	00000073          	ecall
 ret
    1442:	8082                	ret

0000000000001444 <link>:
.global link
link:
 li a7, SYS_link
    1444:	48cd                	li	a7,19
 ecall
    1446:	00000073          	ecall
 ret
    144a:	8082                	ret

000000000000144c <mkdir>:
.global mkdir
mkdir:
 li a7, SYS_mkdir
    144c:	48d1                	li	a7,20
 ecall
    144e:	00000073          	ecall
 ret
    1452:	8082                	ret

0000000000001454 <chdir>:
.global chdir
chdir:
 li a7, SYS_chdir
    1454:	48a5                	li	a7,9
 ecall
    1456:	00000073          	ecall
 ret
    145a:	8082                	ret

000000000000145c <dup>:
.global dup
dup:
 li a7, SYS_dup
    145c:	48a9                	li	a7,10
 ecall
    145e:	00000073          	ecall
 ret
    1462:	8082                	ret

0000000000001464 <getpid>:
.global getpid
getpid:
 li a7, SYS_getpid
    1464:	48ad                	li	a7,11
 ecall
    1466:	00000073          	ecall
 ret
    146a:	8082                	ret

000000000000146c <sbrk>:
.global sbrk
sbrk:
 li a7, SYS_sbrk
    146c:	48b1                	li	a7,12
 ecall
    146e:	00000073          	ecall
 ret
    1472:	8082                	ret

0000000000001474 <sleep>:
.global sleep
sleep:
 li a7, SYS_sleep
    1474:	48b5                	li	a7,13
 ecall
    1476:	00000073          	ecall
 ret
    147a:	8082                	ret

000000000000147c <uptime>:
.global uptime
uptime:
 li a7, SYS_uptime
    147c:	48b9                	li	a7,14
 ecall
    147e:	00000073          	ecall
 ret
    1482:	8082                	ret

0000000000001484 <trace>:
.global trace
trace:
 li a7, SYS_trace
    1484:	48d9                	li	a7,22
 ecall
    1486:	00000073          	ecall
 ret
    148a:	8082                	ret

000000000000148c <sysinfo>:
.global sysinfo
sysinfo:
 li a7, SYS_sysinfo
    148c:	48dd                	li	a7,23
 ecall
    148e:	00000073          	ecall
 ret
    1492:	8082                	ret

0000000000001494 <putc>:

static char digits[] = "0123456789ABCDEF";

static void
putc(int fd, char c)
{
    1494:	1101                	addi	sp,sp,-32
    1496:	ec06                	sd	ra,24(sp)
    1498:	e822                	sd	s0,16(sp)
    149a:	1000                	addi	s0,sp,32
    149c:	87aa                	mv	a5,a0
    149e:	872e                	mv	a4,a1
    14a0:	fef42623          	sw	a5,-20(s0)
    14a4:	87ba                	mv	a5,a4
    14a6:	fef405a3          	sb	a5,-21(s0)
  write(fd, &c, 1);
    14aa:	feb40713          	addi	a4,s0,-21
    14ae:	fec42783          	lw	a5,-20(s0)
    14b2:	4605                	li	a2,1
    14b4:	85ba                	mv	a1,a4
    14b6:	853e                	mv	a0,a5
    14b8:	00000097          	auipc	ra,0x0
    14bc:	f4c080e7          	jalr	-180(ra) # 1404 <write>
}
    14c0:	0001                	nop
    14c2:	60e2                	ld	ra,24(sp)
    14c4:	6442                	ld	s0,16(sp)
    14c6:	6105                	addi	sp,sp,32
    14c8:	8082                	ret

00000000000014ca <printint>:

static void
printint(int fd, int xx, int base, int sgn)
{
    14ca:	7139                	addi	sp,sp,-64
    14cc:	fc06                	sd	ra,56(sp)
    14ce:	f822                	sd	s0,48(sp)
    14d0:	0080                	addi	s0,sp,64
    14d2:	87aa                	mv	a5,a0
    14d4:	8736                	mv	a4,a3
    14d6:	fcf42623          	sw	a5,-52(s0)
    14da:	87ae                	mv	a5,a1
    14dc:	fcf42423          	sw	a5,-56(s0)
    14e0:	87b2                	mv	a5,a2
    14e2:	fcf42223          	sw	a5,-60(s0)
    14e6:	87ba                	mv	a5,a4
    14e8:	fcf42023          	sw	a5,-64(s0)
  char buf[16];
  int i, neg;
  uint x;

  neg = 0;
    14ec:	fe042423          	sw	zero,-24(s0)
  if(sgn && xx < 0){
    14f0:	fc042783          	lw	a5,-64(s0)
    14f4:	2781                	sext.w	a5,a5
    14f6:	c38d                	beqz	a5,1518 <printint+0x4e>
    14f8:	fc842783          	lw	a5,-56(s0)
    14fc:	2781                	sext.w	a5,a5
    14fe:	0007dd63          	bgez	a5,1518 <printint+0x4e>
    neg = 1;
    1502:	4785                	li	a5,1
    1504:	fef42423          	sw	a5,-24(s0)
    x = -xx;
    1508:	fc842783          	lw	a5,-56(s0)
    150c:	40f007bb          	negw	a5,a5
    1510:	2781                	sext.w	a5,a5
    1512:	fef42223          	sw	a5,-28(s0)
    1516:	a029                	j	1520 <printint+0x56>
  } else {
    x = xx;
    1518:	fc842783          	lw	a5,-56(s0)
    151c:	fef42223          	sw	a5,-28(s0)
  }

  i = 0;
    1520:	fe042623          	sw	zero,-20(s0)
  do{
    buf[i++] = digits[x % base];
    1524:	fc442783          	lw	a5,-60(s0)
    1528:	fe442703          	lw	a4,-28(s0)
    152c:	02f777bb          	remuw	a5,a4,a5
    1530:	0007861b          	sext.w	a2,a5
    1534:	fec42783          	lw	a5,-20(s0)
    1538:	0017871b          	addiw	a4,a5,1
    153c:	fee42623          	sw	a4,-20(s0)
    1540:	00001697          	auipc	a3,0x1
    1544:	a2068693          	addi	a3,a3,-1504 # 1f60 <digits>
    1548:	02061713          	slli	a4,a2,0x20
    154c:	9301                	srli	a4,a4,0x20
    154e:	9736                	add	a4,a4,a3
    1550:	00074703          	lbu	a4,0(a4)
    1554:	ff040693          	addi	a3,s0,-16
    1558:	97b6                	add	a5,a5,a3
    155a:	fee78023          	sb	a4,-32(a5)
  }while((x /= base) != 0);
    155e:	fc442783          	lw	a5,-60(s0)
    1562:	fe442703          	lw	a4,-28(s0)
    1566:	02f757bb          	divuw	a5,a4,a5
    156a:	fef42223          	sw	a5,-28(s0)
    156e:	fe442783          	lw	a5,-28(s0)
    1572:	2781                	sext.w	a5,a5
    1574:	fbc5                	bnez	a5,1524 <printint+0x5a>
  if(neg)
    1576:	fe842783          	lw	a5,-24(s0)
    157a:	2781                	sext.w	a5,a5
    157c:	cf95                	beqz	a5,15b8 <printint+0xee>
    buf[i++] = '-';
    157e:	fec42783          	lw	a5,-20(s0)
    1582:	0017871b          	addiw	a4,a5,1
    1586:	fee42623          	sw	a4,-20(s0)
    158a:	ff040713          	addi	a4,s0,-16
    158e:	97ba                	add	a5,a5,a4
    1590:	02d00713          	li	a4,45
    1594:	fee78023          	sb	a4,-32(a5)

  while(--i >= 0)
    1598:	a005                	j	15b8 <printint+0xee>
    putc(fd, buf[i]);
    159a:	fec42783          	lw	a5,-20(s0)
    159e:	ff040713          	addi	a4,s0,-16
    15a2:	97ba                	add	a5,a5,a4
    15a4:	fe07c703          	lbu	a4,-32(a5)
    15a8:	fcc42783          	lw	a5,-52(s0)
    15ac:	85ba                	mv	a1,a4
    15ae:	853e                	mv	a0,a5
    15b0:	00000097          	auipc	ra,0x0
    15b4:	ee4080e7          	jalr	-284(ra) # 1494 <putc>
  while(--i >= 0)
    15b8:	fec42783          	lw	a5,-20(s0)
    15bc:	37fd                	addiw	a5,a5,-1
    15be:	fef42623          	sw	a5,-20(s0)
    15c2:	fec42783          	lw	a5,-20(s0)
    15c6:	2781                	sext.w	a5,a5
    15c8:	fc07d9e3          	bgez	a5,159a <printint+0xd0>
}
    15cc:	0001                	nop
    15ce:	0001                	nop
    15d0:	70e2                	ld	ra,56(sp)
    15d2:	7442                	ld	s0,48(sp)
    15d4:	6121                	addi	sp,sp,64
    15d6:	8082                	ret

00000000000015d8 <printptr>:

static void
printptr(int fd, uint64 x) {
    15d8:	7179                	addi	sp,sp,-48
    15da:	f406                	sd	ra,40(sp)
    15dc:	f022                	sd	s0,32(sp)
    15de:	1800                	addi	s0,sp,48
    15e0:	87aa                	mv	a5,a0
    15e2:	fcb43823          	sd	a1,-48(s0)
    15e6:	fcf42e23          	sw	a5,-36(s0)
  int i;
  putc(fd, '0');
    15ea:	fdc42783          	lw	a5,-36(s0)
    15ee:	03000593          	li	a1,48
    15f2:	853e                	mv	a0,a5
    15f4:	00000097          	auipc	ra,0x0
    15f8:	ea0080e7          	jalr	-352(ra) # 1494 <putc>
  putc(fd, 'x');
    15fc:	fdc42783          	lw	a5,-36(s0)
    1600:	07800593          	li	a1,120
    1604:	853e                	mv	a0,a5
    1606:	00000097          	auipc	ra,0x0
    160a:	e8e080e7          	jalr	-370(ra) # 1494 <putc>
  for (i = 0; i < (sizeof(uint64) * 2); i++, x <<= 4)
    160e:	fe042623          	sw	zero,-20(s0)
    1612:	a82d                	j	164c <printptr+0x74>
    putc(fd, digits[x >> (sizeof(uint64) * 8 - 4)]);
    1614:	fd043783          	ld	a5,-48(s0)
    1618:	93f1                	srli	a5,a5,0x3c
    161a:	00001717          	auipc	a4,0x1
    161e:	94670713          	addi	a4,a4,-1722 # 1f60 <digits>
    1622:	97ba                	add	a5,a5,a4
    1624:	0007c703          	lbu	a4,0(a5)
    1628:	fdc42783          	lw	a5,-36(s0)
    162c:	85ba                	mv	a1,a4
    162e:	853e                	mv	a0,a5
    1630:	00000097          	auipc	ra,0x0
    1634:	e64080e7          	jalr	-412(ra) # 1494 <putc>
  for (i = 0; i < (sizeof(uint64) * 2); i++, x <<= 4)
    1638:	fec42783          	lw	a5,-20(s0)
    163c:	2785                	addiw	a5,a5,1
    163e:	fef42623          	sw	a5,-20(s0)
    1642:	fd043783          	ld	a5,-48(s0)
    1646:	0792                	slli	a5,a5,0x4
    1648:	fcf43823          	sd	a5,-48(s0)
    164c:	fec42783          	lw	a5,-20(s0)
    1650:	873e                	mv	a4,a5
    1652:	47bd                	li	a5,15
    1654:	fce7f0e3          	bgeu	a5,a4,1614 <printptr+0x3c>
}
    1658:	0001                	nop
    165a:	0001                	nop
    165c:	70a2                	ld	ra,40(sp)
    165e:	7402                	ld	s0,32(sp)
    1660:	6145                	addi	sp,sp,48
    1662:	8082                	ret

0000000000001664 <vprintf>:

// Print to the given fd. Only understands %d, %x, %p, %s.
void
vprintf(int fd, const char *fmt, va_list ap)
{
    1664:	715d                	addi	sp,sp,-80
    1666:	e486                	sd	ra,72(sp)
    1668:	e0a2                	sd	s0,64(sp)
    166a:	0880                	addi	s0,sp,80
    166c:	87aa                	mv	a5,a0
    166e:	fcb43023          	sd	a1,-64(s0)
    1672:	fac43c23          	sd	a2,-72(s0)
    1676:	fcf42623          	sw	a5,-52(s0)
  char *s;
  int c, i, state;

  state = 0;
    167a:	fe042023          	sw	zero,-32(s0)
  for(i = 0; fmt[i]; i++){
    167e:	fe042223          	sw	zero,-28(s0)
    1682:	a42d                	j	18ac <vprintf+0x248>
    c = fmt[i] & 0xff;
    1684:	fe442783          	lw	a5,-28(s0)
    1688:	fc043703          	ld	a4,-64(s0)
    168c:	97ba                	add	a5,a5,a4
    168e:	0007c783          	lbu	a5,0(a5)
    1692:	fcf42e23          	sw	a5,-36(s0)
    if(state == 0){
    1696:	fe042783          	lw	a5,-32(s0)
    169a:	2781                	sext.w	a5,a5
    169c:	eb9d                	bnez	a5,16d2 <vprintf+0x6e>
      if(c == '%'){
    169e:	fdc42783          	lw	a5,-36(s0)
    16a2:	0007871b          	sext.w	a4,a5
    16a6:	02500793          	li	a5,37
    16aa:	00f71763          	bne	a4,a5,16b8 <vprintf+0x54>
        state = '%';
    16ae:	02500793          	li	a5,37
    16b2:	fef42023          	sw	a5,-32(s0)
    16b6:	a2f5                	j	18a2 <vprintf+0x23e>
      } else {
        putc(fd, c);
    16b8:	fdc42783          	lw	a5,-36(s0)
    16bc:	0ff7f713          	andi	a4,a5,255
    16c0:	fcc42783          	lw	a5,-52(s0)
    16c4:	85ba                	mv	a1,a4
    16c6:	853e                	mv	a0,a5
    16c8:	00000097          	auipc	ra,0x0
    16cc:	dcc080e7          	jalr	-564(ra) # 1494 <putc>
    16d0:	aac9                	j	18a2 <vprintf+0x23e>
      }
    } else if(state == '%'){
    16d2:	fe042783          	lw	a5,-32(s0)
    16d6:	0007871b          	sext.w	a4,a5
    16da:	02500793          	li	a5,37
    16de:	1cf71263          	bne	a4,a5,18a2 <vprintf+0x23e>
      if(c == 'd'){
    16e2:	fdc42783          	lw	a5,-36(s0)
    16e6:	0007871b          	sext.w	a4,a5
    16ea:	06400793          	li	a5,100
    16ee:	02f71463          	bne	a4,a5,1716 <vprintf+0xb2>
        printint(fd, va_arg(ap, int), 10, 1);
    16f2:	fb843783          	ld	a5,-72(s0)
    16f6:	00878713          	addi	a4,a5,8
    16fa:	fae43c23          	sd	a4,-72(s0)
    16fe:	4398                	lw	a4,0(a5)
    1700:	fcc42783          	lw	a5,-52(s0)
    1704:	4685                	li	a3,1
    1706:	4629                	li	a2,10
    1708:	85ba                	mv	a1,a4
    170a:	853e                	mv	a0,a5
    170c:	00000097          	auipc	ra,0x0
    1710:	dbe080e7          	jalr	-578(ra) # 14ca <printint>
    1714:	a269                	j	189e <vprintf+0x23a>
      } else if(c == 'l') {
    1716:	fdc42783          	lw	a5,-36(s0)
    171a:	0007871b          	sext.w	a4,a5
    171e:	06c00793          	li	a5,108
    1722:	02f71663          	bne	a4,a5,174e <vprintf+0xea>
        printint(fd, va_arg(ap, uint64), 10, 0);
    1726:	fb843783          	ld	a5,-72(s0)
    172a:	00878713          	addi	a4,a5,8
    172e:	fae43c23          	sd	a4,-72(s0)
    1732:	639c                	ld	a5,0(a5)
    1734:	0007871b          	sext.w	a4,a5
    1738:	fcc42783          	lw	a5,-52(s0)
    173c:	4681                	li	a3,0
    173e:	4629                	li	a2,10
    1740:	85ba                	mv	a1,a4
    1742:	853e                	mv	a0,a5
    1744:	00000097          	auipc	ra,0x0
    1748:	d86080e7          	jalr	-634(ra) # 14ca <printint>
    174c:	aa89                	j	189e <vprintf+0x23a>
      } else if(c == 'x') {
    174e:	fdc42783          	lw	a5,-36(s0)
    1752:	0007871b          	sext.w	a4,a5
    1756:	07800793          	li	a5,120
    175a:	02f71463          	bne	a4,a5,1782 <vprintf+0x11e>
        printint(fd, va_arg(ap, int), 16, 0);
    175e:	fb843783          	ld	a5,-72(s0)
    1762:	00878713          	addi	a4,a5,8
    1766:	fae43c23          	sd	a4,-72(s0)
    176a:	4398                	lw	a4,0(a5)
    176c:	fcc42783          	lw	a5,-52(s0)
    1770:	4681                	li	a3,0
    1772:	4641                	li	a2,16
    1774:	85ba                	mv	a1,a4
    1776:	853e                	mv	a0,a5
    1778:	00000097          	auipc	ra,0x0
    177c:	d52080e7          	jalr	-686(ra) # 14ca <printint>
    1780:	aa39                	j	189e <vprintf+0x23a>
      } else if(c == 'p') {
    1782:	fdc42783          	lw	a5,-36(s0)
    1786:	0007871b          	sext.w	a4,a5
    178a:	07000793          	li	a5,112
    178e:	02f71263          	bne	a4,a5,17b2 <vprintf+0x14e>
        printptr(fd, va_arg(ap, uint64));
    1792:	fb843783          	ld	a5,-72(s0)
    1796:	00878713          	addi	a4,a5,8
    179a:	fae43c23          	sd	a4,-72(s0)
    179e:	6398                	ld	a4,0(a5)
    17a0:	fcc42783          	lw	a5,-52(s0)
    17a4:	85ba                	mv	a1,a4
    17a6:	853e                	mv	a0,a5
    17a8:	00000097          	auipc	ra,0x0
    17ac:	e30080e7          	jalr	-464(ra) # 15d8 <printptr>
    17b0:	a0fd                	j	189e <vprintf+0x23a>
      } else if(c == 's'){
    17b2:	fdc42783          	lw	a5,-36(s0)
    17b6:	0007871b          	sext.w	a4,a5
    17ba:	07300793          	li	a5,115
    17be:	04f71c63          	bne	a4,a5,1816 <vprintf+0x1b2>
        s = va_arg(ap, char*);
    17c2:	fb843783          	ld	a5,-72(s0)
    17c6:	00878713          	addi	a4,a5,8
    17ca:	fae43c23          	sd	a4,-72(s0)
    17ce:	639c                	ld	a5,0(a5)
    17d0:	fef43423          	sd	a5,-24(s0)
        if(s == 0)
    17d4:	fe843783          	ld	a5,-24(s0)
    17d8:	eb8d                	bnez	a5,180a <vprintf+0x1a6>
          s = "(null)";
    17da:	00000797          	auipc	a5,0x0
    17de:	77e78793          	addi	a5,a5,1918 # 1f58 <malloc+0x444>
    17e2:	fef43423          	sd	a5,-24(s0)
        while(*s != 0){
    17e6:	a015                	j	180a <vprintf+0x1a6>
          putc(fd, *s);
    17e8:	fe843783          	ld	a5,-24(s0)
    17ec:	0007c703          	lbu	a4,0(a5)
    17f0:	fcc42783          	lw	a5,-52(s0)
    17f4:	85ba                	mv	a1,a4
    17f6:	853e                	mv	a0,a5
    17f8:	00000097          	auipc	ra,0x0
    17fc:	c9c080e7          	jalr	-868(ra) # 1494 <putc>
          s++;
    1800:	fe843783          	ld	a5,-24(s0)
    1804:	0785                	addi	a5,a5,1
    1806:	fef43423          	sd	a5,-24(s0)
        while(*s != 0){
    180a:	fe843783          	ld	a5,-24(s0)
    180e:	0007c783          	lbu	a5,0(a5)
    1812:	fbf9                	bnez	a5,17e8 <vprintf+0x184>
    1814:	a069                	j	189e <vprintf+0x23a>
        }
      } else if(c == 'c'){
    1816:	fdc42783          	lw	a5,-36(s0)
    181a:	0007871b          	sext.w	a4,a5
    181e:	06300793          	li	a5,99
    1822:	02f71463          	bne	a4,a5,184a <vprintf+0x1e6>
        putc(fd, va_arg(ap, uint));
    1826:	fb843783          	ld	a5,-72(s0)
    182a:	00878713          	addi	a4,a5,8
    182e:	fae43c23          	sd	a4,-72(s0)
    1832:	439c                	lw	a5,0(a5)
    1834:	0ff7f713          	andi	a4,a5,255
    1838:	fcc42783          	lw	a5,-52(s0)
    183c:	85ba                	mv	a1,a4
    183e:	853e                	mv	a0,a5
    1840:	00000097          	auipc	ra,0x0
    1844:	c54080e7          	jalr	-940(ra) # 1494 <putc>
    1848:	a899                	j	189e <vprintf+0x23a>
      } else if(c == '%'){
    184a:	fdc42783          	lw	a5,-36(s0)
    184e:	0007871b          	sext.w	a4,a5
    1852:	02500793          	li	a5,37
    1856:	00f71f63          	bne	a4,a5,1874 <vprintf+0x210>
        putc(fd, c);
    185a:	fdc42783          	lw	a5,-36(s0)
    185e:	0ff7f713          	andi	a4,a5,255
    1862:	fcc42783          	lw	a5,-52(s0)
    1866:	85ba                	mv	a1,a4
    1868:	853e                	mv	a0,a5
    186a:	00000097          	auipc	ra,0x0
    186e:	c2a080e7          	jalr	-982(ra) # 1494 <putc>
    1872:	a035                	j	189e <vprintf+0x23a>
      } else {
        // Unknown % sequence.  Print it to draw attention.
        putc(fd, '%');
    1874:	fcc42783          	lw	a5,-52(s0)
    1878:	02500593          	li	a1,37
    187c:	853e                	mv	a0,a5
    187e:	00000097          	auipc	ra,0x0
    1882:	c16080e7          	jalr	-1002(ra) # 1494 <putc>
        putc(fd, c);
    1886:	fdc42783          	lw	a5,-36(s0)
    188a:	0ff7f713          	andi	a4,a5,255
    188e:	fcc42783          	lw	a5,-52(s0)
    1892:	85ba                	mv	a1,a4
    1894:	853e                	mv	a0,a5
    1896:	00000097          	auipc	ra,0x0
    189a:	bfe080e7          	jalr	-1026(ra) # 1494 <putc>
      }
      state = 0;
    189e:	fe042023          	sw	zero,-32(s0)
  for(i = 0; fmt[i]; i++){
    18a2:	fe442783          	lw	a5,-28(s0)
    18a6:	2785                	addiw	a5,a5,1
    18a8:	fef42223          	sw	a5,-28(s0)
    18ac:	fe442783          	lw	a5,-28(s0)
    18b0:	fc043703          	ld	a4,-64(s0)
    18b4:	97ba                	add	a5,a5,a4
    18b6:	0007c783          	lbu	a5,0(a5)
    18ba:	dc0795e3          	bnez	a5,1684 <vprintf+0x20>
    }
  }
}
    18be:	0001                	nop
    18c0:	0001                	nop
    18c2:	60a6                	ld	ra,72(sp)
    18c4:	6406                	ld	s0,64(sp)
    18c6:	6161                	addi	sp,sp,80
    18c8:	8082                	ret

00000000000018ca <fprintf>:

void
fprintf(int fd, const char *fmt, ...)
{
    18ca:	7159                	addi	sp,sp,-112
    18cc:	fc06                	sd	ra,56(sp)
    18ce:	f822                	sd	s0,48(sp)
    18d0:	0080                	addi	s0,sp,64
    18d2:	fcb43823          	sd	a1,-48(s0)
    18d6:	e010                	sd	a2,0(s0)
    18d8:	e414                	sd	a3,8(s0)
    18da:	e818                	sd	a4,16(s0)
    18dc:	ec1c                	sd	a5,24(s0)
    18de:	03043023          	sd	a6,32(s0)
    18e2:	03143423          	sd	a7,40(s0)
    18e6:	87aa                	mv	a5,a0
    18e8:	fcf42e23          	sw	a5,-36(s0)
  va_list ap;

  va_start(ap, fmt);
    18ec:	03040793          	addi	a5,s0,48
    18f0:	fcf43423          	sd	a5,-56(s0)
    18f4:	fc843783          	ld	a5,-56(s0)
    18f8:	fd078793          	addi	a5,a5,-48
    18fc:	fef43423          	sd	a5,-24(s0)
  vprintf(fd, fmt, ap);
    1900:	fe843703          	ld	a4,-24(s0)
    1904:	fdc42783          	lw	a5,-36(s0)
    1908:	863a                	mv	a2,a4
    190a:	fd043583          	ld	a1,-48(s0)
    190e:	853e                	mv	a0,a5
    1910:	00000097          	auipc	ra,0x0
    1914:	d54080e7          	jalr	-684(ra) # 1664 <vprintf>
}
    1918:	0001                	nop
    191a:	70e2                	ld	ra,56(sp)
    191c:	7442                	ld	s0,48(sp)
    191e:	6165                	addi	sp,sp,112
    1920:	8082                	ret

0000000000001922 <printf>:

void
printf(const char *fmt, ...)
{
    1922:	7159                	addi	sp,sp,-112
    1924:	f406                	sd	ra,40(sp)
    1926:	f022                	sd	s0,32(sp)
    1928:	1800                	addi	s0,sp,48
    192a:	fca43c23          	sd	a0,-40(s0)
    192e:	e40c                	sd	a1,8(s0)
    1930:	e810                	sd	a2,16(s0)
    1932:	ec14                	sd	a3,24(s0)
    1934:	f018                	sd	a4,32(s0)
    1936:	f41c                	sd	a5,40(s0)
    1938:	03043823          	sd	a6,48(s0)
    193c:	03143c23          	sd	a7,56(s0)
  va_list ap;

  va_start(ap, fmt);
    1940:	04040793          	addi	a5,s0,64
    1944:	fcf43823          	sd	a5,-48(s0)
    1948:	fd043783          	ld	a5,-48(s0)
    194c:	fc878793          	addi	a5,a5,-56
    1950:	fef43423          	sd	a5,-24(s0)
  vprintf(1, fmt, ap);
    1954:	fe843783          	ld	a5,-24(s0)
    1958:	863e                	mv	a2,a5
    195a:	fd843583          	ld	a1,-40(s0)
    195e:	4505                	li	a0,1
    1960:	00000097          	auipc	ra,0x0
    1964:	d04080e7          	jalr	-764(ra) # 1664 <vprintf>
}
    1968:	0001                	nop
    196a:	70a2                	ld	ra,40(sp)
    196c:	7402                	ld	s0,32(sp)
    196e:	6165                	addi	sp,sp,112
    1970:	8082                	ret

0000000000001972 <free>:
static Header base;
static Header *freep;

void
free(void *ap)
{
    1972:	7179                	addi	sp,sp,-48
    1974:	f422                	sd	s0,40(sp)
    1976:	1800                	addi	s0,sp,48
    1978:	fca43c23          	sd	a0,-40(s0)
  Header *bp, *p;

  bp = (Header*)ap - 1;
    197c:	fd843783          	ld	a5,-40(s0)
    1980:	17c1                	addi	a5,a5,-16
    1982:	fef43023          	sd	a5,-32(s0)
  for(p = freep; !(bp > p && bp < p->s.ptr); p = p->s.ptr)
    1986:	00001797          	auipc	a5,0x1
    198a:	9f278793          	addi	a5,a5,-1550 # 2378 <freep>
    198e:	639c                	ld	a5,0(a5)
    1990:	fef43423          	sd	a5,-24(s0)
    1994:	a815                	j	19c8 <free+0x56>
    if(p >= p->s.ptr && (bp > p || bp < p->s.ptr))
    1996:	fe843783          	ld	a5,-24(s0)
    199a:	639c                	ld	a5,0(a5)
    199c:	fe843703          	ld	a4,-24(s0)
    19a0:	00f76f63          	bltu	a4,a5,19be <free+0x4c>
    19a4:	fe043703          	ld	a4,-32(s0)
    19a8:	fe843783          	ld	a5,-24(s0)
    19ac:	02e7eb63          	bltu	a5,a4,19e2 <free+0x70>
    19b0:	fe843783          	ld	a5,-24(s0)
    19b4:	639c                	ld	a5,0(a5)
    19b6:	fe043703          	ld	a4,-32(s0)
    19ba:	02f76463          	bltu	a4,a5,19e2 <free+0x70>
  for(p = freep; !(bp > p && bp < p->s.ptr); p = p->s.ptr)
    19be:	fe843783          	ld	a5,-24(s0)
    19c2:	639c                	ld	a5,0(a5)
    19c4:	fef43423          	sd	a5,-24(s0)
    19c8:	fe043703          	ld	a4,-32(s0)
    19cc:	fe843783          	ld	a5,-24(s0)
    19d0:	fce7f3e3          	bgeu	a5,a4,1996 <free+0x24>
    19d4:	fe843783          	ld	a5,-24(s0)
    19d8:	639c                	ld	a5,0(a5)
    19da:	fe043703          	ld	a4,-32(s0)
    19de:	faf77ce3          	bgeu	a4,a5,1996 <free+0x24>
      break;
  if(bp + bp->s.size == p->s.ptr){
    19e2:	fe043783          	ld	a5,-32(s0)
    19e6:	479c                	lw	a5,8(a5)
    19e8:	1782                	slli	a5,a5,0x20
    19ea:	9381                	srli	a5,a5,0x20
    19ec:	0792                	slli	a5,a5,0x4
    19ee:	fe043703          	ld	a4,-32(s0)
    19f2:	973e                	add	a4,a4,a5
    19f4:	fe843783          	ld	a5,-24(s0)
    19f8:	639c                	ld	a5,0(a5)
    19fa:	02f71763          	bne	a4,a5,1a28 <free+0xb6>
    bp->s.size += p->s.ptr->s.size;
    19fe:	fe043783          	ld	a5,-32(s0)
    1a02:	4798                	lw	a4,8(a5)
    1a04:	fe843783          	ld	a5,-24(s0)
    1a08:	639c                	ld	a5,0(a5)
    1a0a:	479c                	lw	a5,8(a5)
    1a0c:	9fb9                	addw	a5,a5,a4
    1a0e:	0007871b          	sext.w	a4,a5
    1a12:	fe043783          	ld	a5,-32(s0)
    1a16:	c798                	sw	a4,8(a5)
    bp->s.ptr = p->s.ptr->s.ptr;
    1a18:	fe843783          	ld	a5,-24(s0)
    1a1c:	639c                	ld	a5,0(a5)
    1a1e:	6398                	ld	a4,0(a5)
    1a20:	fe043783          	ld	a5,-32(s0)
    1a24:	e398                	sd	a4,0(a5)
    1a26:	a039                	j	1a34 <free+0xc2>
  } else
    bp->s.ptr = p->s.ptr;
    1a28:	fe843783          	ld	a5,-24(s0)
    1a2c:	6398                	ld	a4,0(a5)
    1a2e:	fe043783          	ld	a5,-32(s0)
    1a32:	e398                	sd	a4,0(a5)
  if(p + p->s.size == bp){
    1a34:	fe843783          	ld	a5,-24(s0)
    1a38:	479c                	lw	a5,8(a5)
    1a3a:	1782                	slli	a5,a5,0x20
    1a3c:	9381                	srli	a5,a5,0x20
    1a3e:	0792                	slli	a5,a5,0x4
    1a40:	fe843703          	ld	a4,-24(s0)
    1a44:	97ba                	add	a5,a5,a4
    1a46:	fe043703          	ld	a4,-32(s0)
    1a4a:	02f71563          	bne	a4,a5,1a74 <free+0x102>
    p->s.size += bp->s.size;
    1a4e:	fe843783          	ld	a5,-24(s0)
    1a52:	4798                	lw	a4,8(a5)
    1a54:	fe043783          	ld	a5,-32(s0)
    1a58:	479c                	lw	a5,8(a5)
    1a5a:	9fb9                	addw	a5,a5,a4
    1a5c:	0007871b          	sext.w	a4,a5
    1a60:	fe843783          	ld	a5,-24(s0)
    1a64:	c798                	sw	a4,8(a5)
    p->s.ptr = bp->s.ptr;
    1a66:	fe043783          	ld	a5,-32(s0)
    1a6a:	6398                	ld	a4,0(a5)
    1a6c:	fe843783          	ld	a5,-24(s0)
    1a70:	e398                	sd	a4,0(a5)
    1a72:	a031                	j	1a7e <free+0x10c>
  } else
    p->s.ptr = bp;
    1a74:	fe843783          	ld	a5,-24(s0)
    1a78:	fe043703          	ld	a4,-32(s0)
    1a7c:	e398                	sd	a4,0(a5)
  freep = p;
    1a7e:	00001797          	auipc	a5,0x1
    1a82:	8fa78793          	addi	a5,a5,-1798 # 2378 <freep>
    1a86:	fe843703          	ld	a4,-24(s0)
    1a8a:	e398                	sd	a4,0(a5)
}
    1a8c:	0001                	nop
    1a8e:	7422                	ld	s0,40(sp)
    1a90:	6145                	addi	sp,sp,48
    1a92:	8082                	ret

0000000000001a94 <morecore>:

static Header*
morecore(uint nu)
{
    1a94:	7179                	addi	sp,sp,-48
    1a96:	f406                	sd	ra,40(sp)
    1a98:	f022                	sd	s0,32(sp)
    1a9a:	1800                	addi	s0,sp,48
    1a9c:	87aa                	mv	a5,a0
    1a9e:	fcf42e23          	sw	a5,-36(s0)
  char *p;
  Header *hp;

  if(nu < 4096)
    1aa2:	fdc42783          	lw	a5,-36(s0)
    1aa6:	0007871b          	sext.w	a4,a5
    1aaa:	6785                	lui	a5,0x1
    1aac:	00f77563          	bgeu	a4,a5,1ab6 <morecore+0x22>
    nu = 4096;
    1ab0:	6785                	lui	a5,0x1
    1ab2:	fcf42e23          	sw	a5,-36(s0)
  p = sbrk(nu * sizeof(Header));
    1ab6:	fdc42783          	lw	a5,-36(s0)
    1aba:	0047979b          	slliw	a5,a5,0x4
    1abe:	2781                	sext.w	a5,a5
    1ac0:	2781                	sext.w	a5,a5
    1ac2:	853e                	mv	a0,a5
    1ac4:	00000097          	auipc	ra,0x0
    1ac8:	9a8080e7          	jalr	-1624(ra) # 146c <sbrk>
    1acc:	fea43423          	sd	a0,-24(s0)
  if(p == (char*)-1)
    1ad0:	fe843703          	ld	a4,-24(s0)
    1ad4:	57fd                	li	a5,-1
    1ad6:	00f71463          	bne	a4,a5,1ade <morecore+0x4a>
    return 0;
    1ada:	4781                	li	a5,0
    1adc:	a03d                	j	1b0a <morecore+0x76>
  hp = (Header*)p;
    1ade:	fe843783          	ld	a5,-24(s0)
    1ae2:	fef43023          	sd	a5,-32(s0)
  hp->s.size = nu;
    1ae6:	fe043783          	ld	a5,-32(s0)
    1aea:	fdc42703          	lw	a4,-36(s0)
    1aee:	c798                	sw	a4,8(a5)
  free((void*)(hp + 1));
    1af0:	fe043783          	ld	a5,-32(s0)
    1af4:	07c1                	addi	a5,a5,16
    1af6:	853e                	mv	a0,a5
    1af8:	00000097          	auipc	ra,0x0
    1afc:	e7a080e7          	jalr	-390(ra) # 1972 <free>
  return freep;
    1b00:	00001797          	auipc	a5,0x1
    1b04:	87878793          	addi	a5,a5,-1928 # 2378 <freep>
    1b08:	639c                	ld	a5,0(a5)
}
    1b0a:	853e                	mv	a0,a5
    1b0c:	70a2                	ld	ra,40(sp)
    1b0e:	7402                	ld	s0,32(sp)
    1b10:	6145                	addi	sp,sp,48
    1b12:	8082                	ret

0000000000001b14 <malloc>:

void*
malloc(uint nbytes)
{
    1b14:	7139                	addi	sp,sp,-64
    1b16:	fc06                	sd	ra,56(sp)
    1b18:	f822                	sd	s0,48(sp)
    1b1a:	0080                	addi	s0,sp,64
    1b1c:	87aa                	mv	a5,a0
    1b1e:	fcf42623          	sw	a5,-52(s0)
  Header *p, *prevp;
  uint nunits;

  nunits = (nbytes + sizeof(Header) - 1)/sizeof(Header) + 1;
    1b22:	fcc46783          	lwu	a5,-52(s0)
    1b26:	07bd                	addi	a5,a5,15
    1b28:	8391                	srli	a5,a5,0x4
    1b2a:	2781                	sext.w	a5,a5
    1b2c:	2785                	addiw	a5,a5,1
    1b2e:	fcf42e23          	sw	a5,-36(s0)
  if((prevp = freep) == 0){
    1b32:	00001797          	auipc	a5,0x1
    1b36:	84678793          	addi	a5,a5,-1978 # 2378 <freep>
    1b3a:	639c                	ld	a5,0(a5)
    1b3c:	fef43023          	sd	a5,-32(s0)
    1b40:	fe043783          	ld	a5,-32(s0)
    1b44:	ef95                	bnez	a5,1b80 <malloc+0x6c>
    base.s.ptr = freep = prevp = &base;
    1b46:	00001797          	auipc	a5,0x1
    1b4a:	82278793          	addi	a5,a5,-2014 # 2368 <base>
    1b4e:	fef43023          	sd	a5,-32(s0)
    1b52:	00001797          	auipc	a5,0x1
    1b56:	82678793          	addi	a5,a5,-2010 # 2378 <freep>
    1b5a:	fe043703          	ld	a4,-32(s0)
    1b5e:	e398                	sd	a4,0(a5)
    1b60:	00001797          	auipc	a5,0x1
    1b64:	81878793          	addi	a5,a5,-2024 # 2378 <freep>
    1b68:	6398                	ld	a4,0(a5)
    1b6a:	00000797          	auipc	a5,0x0
    1b6e:	7fe78793          	addi	a5,a5,2046 # 2368 <base>
    1b72:	e398                	sd	a4,0(a5)
    base.s.size = 0;
    1b74:	00000797          	auipc	a5,0x0
    1b78:	7f478793          	addi	a5,a5,2036 # 2368 <base>
    1b7c:	0007a423          	sw	zero,8(a5)
  }
  for(p = prevp->s.ptr; ; prevp = p, p = p->s.ptr){
    1b80:	fe043783          	ld	a5,-32(s0)
    1b84:	639c                	ld	a5,0(a5)
    1b86:	fef43423          	sd	a5,-24(s0)
    if(p->s.size >= nunits){
    1b8a:	fe843783          	ld	a5,-24(s0)
    1b8e:	4798                	lw	a4,8(a5)
    1b90:	fdc42783          	lw	a5,-36(s0)
    1b94:	2781                	sext.w	a5,a5
    1b96:	06f76863          	bltu	a4,a5,1c06 <malloc+0xf2>
      if(p->s.size == nunits)
    1b9a:	fe843783          	ld	a5,-24(s0)
    1b9e:	4798                	lw	a4,8(a5)
    1ba0:	fdc42783          	lw	a5,-36(s0)
    1ba4:	2781                	sext.w	a5,a5
    1ba6:	00e79963          	bne	a5,a4,1bb8 <malloc+0xa4>
        prevp->s.ptr = p->s.ptr;
    1baa:	fe843783          	ld	a5,-24(s0)
    1bae:	6398                	ld	a4,0(a5)
    1bb0:	fe043783          	ld	a5,-32(s0)
    1bb4:	e398                	sd	a4,0(a5)
    1bb6:	a82d                	j	1bf0 <malloc+0xdc>
      else {
        p->s.size -= nunits;
    1bb8:	fe843783          	ld	a5,-24(s0)
    1bbc:	4798                	lw	a4,8(a5)
    1bbe:	fdc42783          	lw	a5,-36(s0)
    1bc2:	40f707bb          	subw	a5,a4,a5
    1bc6:	0007871b          	sext.w	a4,a5
    1bca:	fe843783          	ld	a5,-24(s0)
    1bce:	c798                	sw	a4,8(a5)
        p += p->s.size;
    1bd0:	fe843783          	ld	a5,-24(s0)
    1bd4:	479c                	lw	a5,8(a5)
    1bd6:	1782                	slli	a5,a5,0x20
    1bd8:	9381                	srli	a5,a5,0x20
    1bda:	0792                	slli	a5,a5,0x4
    1bdc:	fe843703          	ld	a4,-24(s0)
    1be0:	97ba                	add	a5,a5,a4
    1be2:	fef43423          	sd	a5,-24(s0)
        p->s.size = nunits;
    1be6:	fe843783          	ld	a5,-24(s0)
    1bea:	fdc42703          	lw	a4,-36(s0)
    1bee:	c798                	sw	a4,8(a5)
      }
      freep = prevp;
    1bf0:	00000797          	auipc	a5,0x0
    1bf4:	78878793          	addi	a5,a5,1928 # 2378 <freep>
    1bf8:	fe043703          	ld	a4,-32(s0)
    1bfc:	e398                	sd	a4,0(a5)
      return (void*)(p + 1);
    1bfe:	fe843783          	ld	a5,-24(s0)
    1c02:	07c1                	addi	a5,a5,16
    1c04:	a091                	j	1c48 <malloc+0x134>
    }
    if(p == freep)
    1c06:	00000797          	auipc	a5,0x0
    1c0a:	77278793          	addi	a5,a5,1906 # 2378 <freep>
    1c0e:	639c                	ld	a5,0(a5)
    1c10:	fe843703          	ld	a4,-24(s0)
    1c14:	02f71063          	bne	a4,a5,1c34 <malloc+0x120>
      if((p = morecore(nunits)) == 0)
    1c18:	fdc42783          	lw	a5,-36(s0)
    1c1c:	853e                	mv	a0,a5
    1c1e:	00000097          	auipc	ra,0x0
    1c22:	e76080e7          	jalr	-394(ra) # 1a94 <morecore>
    1c26:	fea43423          	sd	a0,-24(s0)
    1c2a:	fe843783          	ld	a5,-24(s0)
    1c2e:	e399                	bnez	a5,1c34 <malloc+0x120>
        return 0;
    1c30:	4781                	li	a5,0
    1c32:	a819                	j	1c48 <malloc+0x134>
  for(p = prevp->s.ptr; ; prevp = p, p = p->s.ptr){
    1c34:	fe843783          	ld	a5,-24(s0)
    1c38:	fef43023          	sd	a5,-32(s0)
    1c3c:	fe843783          	ld	a5,-24(s0)
    1c40:	639c                	ld	a5,0(a5)
    1c42:	fef43423          	sd	a5,-24(s0)
    if(p->s.size >= nunits){
    1c46:	b791                	j	1b8a <malloc+0x76>
  }
}
    1c48:	853e                	mv	a0,a5
    1c4a:	70e2                	ld	ra,56(sp)
    1c4c:	7442                	ld	s0,48(sp)
    1c4e:	6121                	addi	sp,sp,64
    1c50:	8082                	ret
